#include "caf/config.hpp"
#include "caf/string_view.hpp"

CAF_PUSH_DEPRECATED_WARNING

#include "caf/net/basp/connection_state.hpp"

#include <string>

namespace caf::net::basp {

std::string to_string(connection_state x) {
  switch (x) {
    default:
      return "???";
    case connection_state::await_handshake_header:
      return "caf::net::basp::connection_state::await_handshake_header";
    case connection_state::await_handshake_payload:
      return "caf::net::basp::connection_state::await_handshake_payload";
    case connection_state::await_header:
      return "caf::net::basp::connection_state::await_header";
    case connection_state::await_payload:
      return "caf::net::basp::connection_state::await_payload";
    case connection_state::shutdown:
      return "caf::net::basp::connection_state::shutdown";
  }
}

bool from_string(string_view in, connection_state& out) {
  if (in == "caf::net::basp::connection_state::await_handshake_header") {
    out = connection_state::await_handshake_header;
    return true;
  }
  if (in == "caf::net::basp::connection_state::await_handshake_payload") {
    out = connection_state::await_handshake_payload;
    return true;
  }
  if (in == "caf::net::basp::connection_state::await_header") {
    out = connection_state::await_header;
    return true;
  }
  if (in == "caf::net::basp::connection_state::await_payload") {
    out = connection_state::await_payload;
    return true;
  }
  if (in == "caf::net::basp::connection_state::shutdown") {
    out = connection_state::shutdown;
    return true;
  }
  return false;
}

bool from_integer(std::underlying_type_t<connection_state> in,
                  connection_state& out) {
  auto result = static_cast<connection_state>(in);
  switch (result) {
    default:
      return false;
    case connection_state::await_handshake_header:
    case connection_state::await_handshake_payload:
    case connection_state::await_header:
    case connection_state::await_payload:
    case connection_state::shutdown:
      out = result;
      return true;
  }
}

} // namespace caf::net::basp

