#include "caf/config.hpp"
#include "caf/string_view.hpp"

CAF_PUSH_DEPRECATED_WARNING

#include "caf/net/basp/message_type.hpp"

#include <string>

namespace caf::net::basp {

std::string to_string(message_type x) {
  switch (x) {
    default:
      return "???";
    case message_type::handshake:
      return "caf::net::basp::message_type::handshake";
    case message_type::actor_message:
      return "caf::net::basp::message_type::actor_message";
    case message_type::resolve_request:
      return "caf::net::basp::message_type::resolve_request";
    case message_type::resolve_response:
      return "caf::net::basp::message_type::resolve_response";
    case message_type::monitor_message:
      return "caf::net::basp::message_type::monitor_message";
    case message_type::down_message:
      return "caf::net::basp::message_type::down_message";
    case message_type::heartbeat:
      return "caf::net::basp::message_type::heartbeat";
  }
}

bool from_string(string_view in, message_type& out) {
  if (in == "caf::net::basp::message_type::handshake") {
    out = message_type::handshake;
    return true;
  }
  if (in == "caf::net::basp::message_type::actor_message") {
    out = message_type::actor_message;
    return true;
  }
  if (in == "caf::net::basp::message_type::resolve_request") {
    out = message_type::resolve_request;
    return true;
  }
  if (in == "caf::net::basp::message_type::resolve_response") {
    out = message_type::resolve_response;
    return true;
  }
  if (in == "caf::net::basp::message_type::monitor_message") {
    out = message_type::monitor_message;
    return true;
  }
  if (in == "caf::net::basp::message_type::down_message") {
    out = message_type::down_message;
    return true;
  }
  if (in == "caf::net::basp::message_type::heartbeat") {
    out = message_type::heartbeat;
    return true;
  }
  return false;
}

bool from_integer(std::underlying_type_t<message_type> in,
                  message_type& out) {
  auto result = static_cast<message_type>(in);
  switch (result) {
    default:
      return false;
    case message_type::handshake:
    case message_type::actor_message:
    case message_type::resolve_request:
    case message_type::resolve_response:
    case message_type::monitor_message:
    case message_type::down_message:
    case message_type::heartbeat:
      out = result;
      return true;
  }
}

} // namespace caf::net::basp

