// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif (plugin mode).


#include "functions.bif.h"
#include "zeek/Func.h"


#line 1 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"

#include "zeek/analyzer/protocol/conn-size/ConnSize.h"
#include "zeek/Reporter.h"
#include "zeek/session/Manager.h"

static zeek::analyzer::Analyzer* GetConnsizeAnalyzer(zeek::Val* cid)
	{
	zeek::Connection* c = zeek::session_mgr->FindConnection(cid);
	if ( ! c )
		return nullptr;

	zeek::analyzer::Analyzer* a = c->FindAnalyzer("CONNSIZE");
	if ( ! a )
		zeek::reporter->Error("connection does not have ConnSize analyzer");

	return a;
	}


#line 34 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::set_current_conn_bytes_threshold_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 35 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"
{
	if ( BiF_ARGS->size() != 3 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("set_current_conn_bytes_threshold() takes exactly 3 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* cid = (zeek::Val*) ((*BiF_ARGS)[0].get());
	zeek_uint_t threshold = (zeek_uint_t) ((*BiF_ARGS)[1].get()->AsCount());
	int is_orig = (int) ((*BiF_ARGS)[2].get()->AsBool());

#line 35 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"

	zeek::analyzer::Analyzer* a = GetConnsizeAnalyzer(cid);
	if ( ! a )
		return zeek::val_mgr->False();

	static_cast<zeek::analyzer::conn_size::ConnSize_Analyzer*>(a)->SetByteAndPacketThreshold(threshold, true, is_orig);

	return zeek::val_mgr->True();
	} // end of BifFunc::set_current_conn_bytes_threshold

#line 43 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"

#line 58 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::set_current_conn_packets_threshold_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 59 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"
{
	if ( BiF_ARGS->size() != 3 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("set_current_conn_packets_threshold() takes exactly 3 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* cid = (zeek::Val*) ((*BiF_ARGS)[0].get());
	zeek_uint_t threshold = (zeek_uint_t) ((*BiF_ARGS)[1].get()->AsCount());
	int is_orig = (int) ((*BiF_ARGS)[2].get()->AsBool());

#line 59 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"

	zeek::analyzer::Analyzer* a = GetConnsizeAnalyzer(cid);
	if ( ! a )
		return zeek::val_mgr->False();

	static_cast<zeek::analyzer::conn_size::ConnSize_Analyzer*>(a)->SetByteAndPacketThreshold(threshold, false, is_orig);

	return zeek::val_mgr->True();
	} // end of BifFunc::set_current_conn_packets_threshold

#line 67 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"

#line 80 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::set_current_conn_duration_threshold_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 81 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("set_current_conn_duration_threshold() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* cid = (zeek::Val*) ((*BiF_ARGS)[0].get());
	double threshold = (double) ((*BiF_ARGS)[1].get()->AsInterval());

#line 81 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"

	zeek::analyzer::Analyzer* a = GetConnsizeAnalyzer(cid);
	if ( ! a )
		return zeek::val_mgr->False();

	static_cast<zeek::analyzer::conn_size::ConnSize_Analyzer*>(a)->SetDurationThreshold(threshold);

	return zeek::val_mgr->True();
	} // end of BifFunc::set_current_conn_duration_threshold

#line 89 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"

#line 102 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::get_current_conn_bytes_threshold_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 103 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("get_current_conn_bytes_threshold() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* cid = (zeek::Val*) ((*BiF_ARGS)[0].get());
	int is_orig = (int) ((*BiF_ARGS)[1].get()->AsBool());

#line 103 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"

	zeek::analyzer::Analyzer* a = GetConnsizeAnalyzer(cid);
	if ( ! a )
		return zeek::val_mgr->Count(0);

	return zeek::val_mgr->Count(static_cast<zeek::analyzer::conn_size::ConnSize_Analyzer*>(a)->GetByteAndPacketThreshold(true, is_orig));
	} // end of BifFunc::get_current_conn_bytes_threshold

#line 109 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"

#line 121 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::get_current_conn_packets_threshold_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 122 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("get_current_conn_packets_threshold() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* cid = (zeek::Val*) ((*BiF_ARGS)[0].get());
	int is_orig = (int) ((*BiF_ARGS)[1].get()->AsBool());

#line 122 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"

	zeek::analyzer::Analyzer* a = GetConnsizeAnalyzer(cid);
	if ( ! a )
		return zeek::val_mgr->Count(0);

	return zeek::val_mgr->Count(static_cast<zeek::analyzer::conn_size::ConnSize_Analyzer*>(a)->GetByteAndPacketThreshold(false, is_orig));
	} // end of BifFunc::get_current_conn_packets_threshold

#line 128 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"

#line 138 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::get_current_conn_duration_threshold_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 139 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("get_current_conn_duration_threshold() takes exactly 1 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* cid = (zeek::Val*) ((*BiF_ARGS)[0].get());

#line 139 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"

	zeek::analyzer::Analyzer* a = GetConnsizeAnalyzer(cid);
	if ( ! a )
		return zeek::make_intrusive<zeek::IntervalVal>(0.0);

	return zeek::make_intrusive<zeek::IntervalVal>(static_cast<zeek::analyzer::conn_size::ConnSize_Analyzer*>(a)->GetDurationThreshold());
	} // end of BifFunc::get_current_conn_duration_threshold

#line 145 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/conn-size/functions.bif"
