// This file is automatically generated from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/dce-rpc/dce_rpc.pac.

#ifndef _builddir_build_BUILD_zeek_6_0_4_build_zeek_6_0_4_src_analyzer_protocol_dce_rpc_dce_rpc_pac_h
#define _builddir_build_BUILD_zeek_6_0_4_build_zeek_6_0_4_src_analyzer_protocol_dce_rpc_dce_rpc_pac_h

#include <vector>

#include "binpac.h"


#include "zeek/binpac_zeek.h"


#include "zeek/analyzer/protocol/dce-rpc/consts.bif.h"
#include "zeek/analyzer/protocol/dce-rpc/types.bif.h"
#include "zeek/analyzer/protocol/dce-rpc/events.bif.h"


#include "zeek/analyzer/Manager.h"

namespace binpac {

namespace DCE_RPC {
class ContextDCE_RPC;
class DCE_RPC_Conn;
enum dce_rpc_ptype {
	DCE_RPC_REQUEST,
	DCE_RPC_PING,
	DCE_RPC_RESPONSE,
	DCE_RPC_FAULT,
	DCE_RPC_WORKING,
	DCE_RPC_NOCALL,
	DCE_RPC_REJECT,
	DCE_RPC_ACK,
	DCE_RPC_CL_CANCEL,
	DCE_RPC_FACK,
	DCE_RPC_CANCEL_ACK,
	DCE_RPC_BIND,
	DCE_RPC_BIND_ACK,
	DCE_RPC_BIND_NAK,
	DCE_RPC_ALTER_CONTEXT,
	DCE_RPC_ALTER_CONTEXT_RESP,
	DCE_RPC_AUTH3,
	DCE_RPC_SHUTDOWN,
	DCE_RPC_CO_CANCEL,
	DCE_RPC_ORPHANED,
	DCE_RPC_RTS,
};
class uuid;
class context_handle;
class DCE_RPC_PDU;
class NDR_Format;
class DCE_RPC_Header;
class Syntax;
class ContextRequest;
class ContextReply;
class ContextList;
class DCE_RPC_Bind;
class DCE_RPC_Bind_Ack;
class DCE_RPC_Request;
class DCE_RPC_Response;
class DCE_RPC_AlterContext;
class DCE_RPC_AlterContext_Resp;
class DCE_RPC_Body;
class DCE_RPC_Auth_wrapper;
class DCE_RPC_Auth;
class DCE_RPC_Flow;
class ATSVC_Request;
class ATSVC_String_Pointer;
class ATSVC_NetrJobAdd;
class ATSVC_Reply;
class ATSVC_JobID;
class epmapper_lookup_req;
class epmapper_map_req;
class epm_uuid;
class epm_port;
class epm_ip;
enum epm_protocol {
	EPM_PROTOCOL_TCP = 7,
	EPM_PROTOCOL_UDP = 8,
	EPM_PROTOCOL_IP = 9,
	EPM_PROTOCOL_UUID = 13,
};
class epm_lhs_data;
class epm_rhs_data;
class epm_lhs;
class epm_rhs;
class epm_floor;
class epm_tower;
class epm_twr_p;
class epm_tower_array;
class epmapper_map_resp;
} // namespace DCE_RPC

int bytestring_to_int(const_bytestring const & s, int base);
double bytestring_to_double(const_bytestring const & s);
int bytestring_casecmp(const_bytestring const & s1, const_charptr const & s2);
bool bytestring_caseprefix(const_bytestring const & s1, const_charptr const & s2);
double network_time();
namespace DCE_RPC {

class ContextDCE_RPC final
{
public:
	ContextDCE_RPC(DCE_RPC_Conn * connection, DCE_RPC_Flow * flow, FlowBuffer * flow_buffer);
	~ContextDCE_RPC();
	
	// Member access functions
	DCE_RPC_Conn * connection() const { return connection_; }
	DCE_RPC_Flow * flow() const { return flow_; }
	FlowBuffer * flow_buffer() const { return flow_buffer_; }
	
protected:
	DCE_RPC_Conn * connection_;
	DCE_RPC_Flow * flow_;
	FlowBuffer * flow_buffer_;
};


class DCE_RPC_Conn final : public binpac::ConnectionAnalyzer
{
public:
	DCE_RPC_Conn(ZeekAnalyzer const & zeek_analyzer);
	~DCE_RPC_Conn();
	
	// Member access functions
	DCE_RPC_Flow * upflow() const { return upflow_; }
	DCE_RPC_Flow * downflow() const { return downflow_; }
	ZeekAnalyzer const & zeek_analyzer() const { return zeek_analyzer_; }
	
	void NewData(bool is_orig, const_byteptr begin, const_byteptr end);
	void NewGap(bool is_orig, int gap_length);
	void FlowEOF(bool is_orig);
	
	// Functions
	bool set_file_id(uint64 fid_in);
	uint16 get_cont_id_opnum_map(uint16 cont_id);
	bool set_cont_id_opnum_map(uint16 cont_id, uint16 opnum);
	bool proc_dce_rpc_pdu(DCE_RPC_PDU * pdu);
	bool proc_dce_rpc_message(DCE_RPC_Header * header);
	bool process_dce_rpc_bind(ContextRequest * req);
	bool process_dce_rpc_alter_context(ContextRequest * req);
	bool process_dce_rpc_bind_ack(DCE_RPC_Bind_Ack * bind);
	bool process_dce_rpc_alter_context_resp(DCE_RPC_AlterContext_Resp * bind);
	bool process_dce_rpc_request(DCE_RPC_Request * req);
	bool process_dce_rpc_response(DCE_RPC_Response * resp);
	bool forward_auth(DCE_RPC_Auth * auth, bool is_orig);
	
protected:
	
	// Additional members

		map<uint16, uint16> cont_id_opnum_map;
		uint64 fid;
	

		zeek::analyzer::Analyzer *gssapi;
		zeek::analyzer::Analyzer *ntlm;
		zeek::analyzer::Analyzer *krb;
	
	DCE_RPC_Flow * upflow_;
	DCE_RPC_Flow * downflow_;
	ZeekAnalyzer zeek_analyzer_;
};


class context_handle final
{
public:
	context_handle();
	~context_handle();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 attrs() const { return attrs_; }
	bytestring const & uuid() const { return uuid_; }
	
protected:
	uint32 attrs_;
	bytestring uuid_;
};


class DCE_RPC_PDU final
{
public:
	DCE_RPC_PDU(bool is_orig);
	~DCE_RPC_PDU();
	int initial_buffer_length() const { return 16; }
	bool ParseBuffer(flow_buffer_t t_flow_buffer, ContextDCE_RPC * t_context);
	
	// Member access functions
	DCE_RPC_Header * header() const { return header_; }
	bytestring const & frag() const { return frag_; }
	DCE_RPC_Auth_wrapper * auth() const { return auth_; }
	bool is_orig() const { return is_orig_; }
	int byteorder() const { return byteorder_; }
	int body_length() const { return body_length_; }
	bool frag_reassembled() const { return frag_reassembled_; }
	DCE_RPC_Body * body() const { BINPAC_ASSERT(has_body()); return body_; }
	bool has_body() const { return has_body_; }
	int proc() const { return proc_; }
	
protected:
	DCE_RPC_Header * header_;
	bytestring frag_;
	DCE_RPC_Auth_wrapper * auth_;
	bool is_orig_;
	int byteorder_;
	int body_length_;
	bool frag_reassembled_;
	DCE_RPC_Body * body_;
	bool has_body_;
	int proc_;
	int buffering_state_;
};


class NDR_Format final
{
public:
	NDR_Format();
	~NDR_Format();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint8 intchar() const { return intchar_; }
	uint8 floatspec() const { return floatspec_; }
	int byteorder() const { return byteorder_; }
	
protected:
	uint8 intchar_;
	uint8 floatspec_;
	int byteorder_;
};


class DCE_RPC_Header final
{
public:
	DCE_RPC_Header(bool is_orig);
	~DCE_RPC_Header();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextDCE_RPC * t_context);
	
	// Member access functions
	uint8 rpc_vers() const { return rpc_vers_; }
	uint8 rpc_vers_minor() const { return rpc_vers_minor_; }
	uint8 PTYPE() const { return PTYPE_; }
	uint8 pfc_flags() const { return pfc_flags_; }
	NDR_Format * packed_drep() const { return packed_drep_; }
	uint16 frag_length() const { return frag_length_; }
	uint16 auth_length() const { return auth_length_; }
	uint32 call_id() const { return call_id_; }
	bool is_orig() const { return is_orig_; }
	int byteorder() const { return byteorder_; }
	int firstfrag() const { return firstfrag_; }
	int lastfrag() const { return lastfrag_; }
	int object() const { return object_; }
	int proc() const { return proc_; }
	
protected:
	uint8 rpc_vers_;
	uint8 rpc_vers_minor_;
	uint8 PTYPE_;
	uint8 pfc_flags_;
	NDR_Format * packed_drep_;
	uint16 frag_length_;
	uint16 auth_length_;
	uint32 call_id_;
	bool is_orig_;
	int byteorder_;
	int firstfrag_;
	int lastfrag_;
	int object_;
	int proc_;
};


class Syntax final
{
public:
	Syntax();
	~Syntax();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	bytestring const & uuid() const { return uuid_; }
	uint16 ver_major() const { return ver_major_; }
	uint16 ver_minor() const { return ver_minor_; }
	
protected:
	bytestring uuid_;
	uint16 ver_major_;
	uint16 ver_minor_;
};


class ContextRequest final
{
public:
	ContextRequest(uint8 ptype);
	~ContextRequest();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextDCE_RPC * t_context, int t_byteorder);
	
	// Member access functions
	uint16 id() const { return id_; }
	uint8 num_syntaxes() const { return num_syntaxes_; }
	Syntax * abstract_syntax() const { return abstract_syntax_; }
	vector<Syntax *> * transfer_syntaxes() const { return transfer_syntaxes_; }
	uint8 ptype() const { return ptype_; }
	int proc() const { return proc_; }
	
protected:
	uint16 id_;
	uint8 num_syntaxes_;
	Syntax * abstract_syntax_;
	vector<Syntax *> * transfer_syntaxes_;
	Syntax * transfer_syntaxes__elem_;
	uint8 ptype_;
	int proc_;
};


class ContextReply final
{
public:
	ContextReply();
	~ContextReply();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint16 ack_result() const { return ack_result_; }
	uint16 ack_reason() const { return ack_reason_; }
	Syntax * syntax() const { return syntax_; }
	
protected:
	uint16 ack_result_;
	uint16 ack_reason_;
	Syntax * syntax_;
};


class ContextList final
{
public:
	ContextList(bool is_request, uint8 ptype);
	~ContextList();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextDCE_RPC * t_context, int t_byteorder);
	
	// Member access functions
	uint8 num_contexts() const { return num_contexts_; }
	int req_reply_case_index() const	{ return req_reply_case_index_; }
	vector<ContextRequest *> * request_contexts() const
		{
		switch ( req_reply_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/dce-rpc/dce_rpc-protocol.pac:92:request_contexts", (int64)req_reply_case_index(), "true");
				break;
			}
		return request_contexts_;
		}
	vector<ContextReply *> * reply_contexts() const
		{
		switch ( req_reply_case_index() )
			{
			case ((bool) 0):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/dce-rpc/dce_rpc-protocol.pac:93:reply_contexts", (int64)req_reply_case_index(), "false");
				break;
			}
		return reply_contexts_;
		}
	bool is_request() const { return is_request_; }
	uint8 ptype() const { return ptype_; }
	
protected:
	uint8 num_contexts_;
	int req_reply_case_index_;
	vector<ContextRequest *> * request_contexts_;
	ContextRequest * request_contexts__elem_;
	vector<ContextReply *> * reply_contexts_;
	ContextReply * reply_contexts__elem_;
	bool is_request_;
	uint8 ptype_;
};


class DCE_RPC_Bind final
{
public:
	DCE_RPC_Bind();
	~DCE_RPC_Bind();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextDCE_RPC * t_context, int t_byteorder);
	
	// Member access functions
	uint16 max_xmit_frag() const { return max_xmit_frag_; }
	uint16 max_recv_frag() const { return max_recv_frag_; }
	uint32 assoc_group_id() const { return assoc_group_id_; }
	ContextList * context_list() const { return context_list_; }
	
protected:
	uint16 max_xmit_frag_;
	uint16 max_recv_frag_;
	uint32 assoc_group_id_;
	ContextList * context_list_;
};


class DCE_RPC_Bind_Ack final
{
public:
	DCE_RPC_Bind_Ack();
	~DCE_RPC_Bind_Ack();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextDCE_RPC * t_context, int t_byteorder);
	
	// Member access functions
	uint16 max_xmit_frag() const { return max_xmit_frag_; }
	uint16 max_recv_frag() const { return max_recv_frag_; }
	uint32 assoc_group_id() const { return assoc_group_id_; }
	uint16 sec_addr_length() const { return sec_addr_length_; }
	bytestring const & sec_addr() const { return sec_addr_; }
	ContextList * contexts() const { return contexts_; }
	int proc() const { return proc_; }
	
protected:
	uint16 max_xmit_frag_;
	uint16 max_recv_frag_;
	uint32 assoc_group_id_;
	uint16 sec_addr_length_;
	bytestring sec_addr_;
	ContextList * contexts_;
	int proc_;
};


class DCE_RPC_Request final
{
public:
	DCE_RPC_Request(DCE_RPC_Header * h);
	~DCE_RPC_Request();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextDCE_RPC * t_context, int t_byteorder);
	
	// Member access functions
	uint32 alloc_hint() const { return alloc_hint_; }
	uint16 context_id() const { return context_id_; }
	uint16 opnum() const { return opnum_; }
	int has_object_case_index() const	{ return has_object_case_index_; }
	bytestring const & uuid() const
		{
		switch ( has_object_case_index() )
			{
			case ((int) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/dce-rpc/dce_rpc-protocol.pac:119:uuid", (int64)has_object_case_index(), "true");
				break;
			}
		return uuid_;
		}
	bytestring const & stub() const { return stub_; }
	DCE_RPC_Header * h() const { return h_; }
	int proc() const { return proc_; }
	
protected:
	uint32 alloc_hint_;
	uint16 context_id_;
	uint16 opnum_;
	int has_object_case_index_;
	bytestring uuid_;
	bytestring stub_;
	DCE_RPC_Header * h_;
	int proc_;
};


class DCE_RPC_Response final
{
public:
	DCE_RPC_Response();
	~DCE_RPC_Response();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextDCE_RPC * t_context, int t_byteorder);
	
	// Member access functions
	uint32 alloc_hint() const { return alloc_hint_; }
	uint16 context_id() const { return context_id_; }
	uint8 cancel_count() const { return cancel_count_; }
	uint8 reserved() const { return reserved_; }
	bytestring const & stub() const { return stub_; }
	int proc() const { return proc_; }
	
protected:
	uint32 alloc_hint_;
	uint16 context_id_;
	uint8 cancel_count_;
	uint8 reserved_;
	bytestring stub_;
	int proc_;
};


class DCE_RPC_AlterContext final
{
public:
	DCE_RPC_AlterContext();
	~DCE_RPC_AlterContext();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextDCE_RPC * t_context, int t_byteorder);
	
	// Member access functions
	uint16 max_xmit_frag() const { return max_xmit_frag_; }
	uint16 max_recv_frag() const { return max_recv_frag_; }
	uint32 assoc_group_id() const { return assoc_group_id_; }
	ContextList * context_list() const { return context_list_; }
	
protected:
	uint16 max_xmit_frag_;
	uint16 max_recv_frag_;
	uint32 assoc_group_id_;
	ContextList * context_list_;
};


class DCE_RPC_AlterContext_Resp final
{
public:
	DCE_RPC_AlterContext_Resp();
	~DCE_RPC_AlterContext_Resp();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextDCE_RPC * t_context, int t_byteorder);
	
	// Member access functions
	uint16 max_xmit_frag() const { return max_xmit_frag_; }
	uint16 max_recv_frag() const { return max_recv_frag_; }
	uint32 assoc_group_id() const { return assoc_group_id_; }
	uint16 sec_addr_length() const { return sec_addr_length_; }
	bytestring const & sec_addr() const { return sec_addr_; }
	ContextList * contexts() const { return contexts_; }
	int proc() const { return proc_; }
	
protected:
	uint16 max_xmit_frag_;
	uint16 max_recv_frag_;
	uint32 assoc_group_id_;
	uint16 sec_addr_length_;
	bytestring sec_addr_;
	ContextList * contexts_;
	int proc_;
};


class DCE_RPC_Body final
{
public:
	DCE_RPC_Body(DCE_RPC_Header * header);
	~DCE_RPC_Body();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextDCE_RPC * t_context, int t_byteorder);
	
	// Member access functions
	uint8 val_case_index() const	{ return val_case_index_; }
	DCE_RPC_Bind * bind() const
		{
		switch ( val_case_index() )
			{
			case ((uint8) 11):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/dce-rpc/dce_rpc-protocol.pac:153:bind", (int64)val_case_index(), "DCE_RPC_BIND");
				break;
			}
		return bind_;
		}
	DCE_RPC_Bind_Ack * bind_ack() const
		{
		switch ( val_case_index() )
			{
			case ((uint8) 12):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/dce-rpc/dce_rpc-protocol.pac:154:bind_ack", (int64)val_case_index(), "DCE_RPC_BIND_ACK");
				break;
			}
		return bind_ack_;
		}
	DCE_RPC_Request * request() const
		{
		switch ( val_case_index() )
			{
			case ((uint8) 0):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/dce-rpc/dce_rpc-protocol.pac:155:request", (int64)val_case_index(), "DCE_RPC_REQUEST");
				break;
			}
		return request_;
		}
	DCE_RPC_Response * response() const
		{
		switch ( val_case_index() )
			{
			case ((uint8) 2):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/dce-rpc/dce_rpc-protocol.pac:156:response", (int64)val_case_index(), "DCE_RPC_RESPONSE");
				break;
			}
		return response_;
		}
	DCE_RPC_AlterContext * alter_context() const
		{
		switch ( val_case_index() )
			{
			case ((uint8) 14):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/dce-rpc/dce_rpc-protocol.pac:157:alter_context", (int64)val_case_index(), "DCE_RPC_ALTER_CONTEXT");
				break;
			}
		return alter_context_;
		}
	DCE_RPC_AlterContext_Resp * alter_resp() const
		{
		switch ( val_case_index() )
			{
			case ((uint8) 15):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/dce-rpc/dce_rpc-protocol.pac:158:alter_resp", (int64)val_case_index(), "DCE_RPC_ALTER_CONTEXT_RESP");
				break;
			}
		return alter_resp_;
		}
	bytestring const & other() const
		{
		return other_;
		}
	DCE_RPC_Header * header() const { return header_; }
	
protected:
	uint8 val_case_index_;
	DCE_RPC_Bind * bind_;
	DCE_RPC_Bind_Ack * bind_ack_;
	DCE_RPC_Request * request_;
	DCE_RPC_Response * response_;
	DCE_RPC_AlterContext * alter_context_;
	DCE_RPC_AlterContext_Resp * alter_resp_;
	bytestring other_;
	DCE_RPC_Header * header_;
};


class DCE_RPC_Auth_wrapper final
{
public:
	DCE_RPC_Auth_wrapper(DCE_RPC_Header * header);
	~DCE_RPC_Auth_wrapper();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextDCE_RPC * t_context, int t_byteorder);
	
	// Member access functions
	uint16 val_case_index() const	{ return val_case_index_; }
	DCE_RPC_Auth * auth() const
		{
		return auth_;
		}
	DCE_RPC_Header * header() const { return header_; }
	
protected:
	uint16 val_case_index_;
	DCE_RPC_Auth * auth_;
	DCE_RPC_Header * header_;
};


class DCE_RPC_Auth final
{
public:
	DCE_RPC_Auth(DCE_RPC_Header * header);
	~DCE_RPC_Auth();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextDCE_RPC * t_context, int t_byteorder);
	
	// Member access functions
	uint8 type() const { return type_; }
	uint8 level() const { return level_; }
	uint8 pad_len() const { return pad_len_; }
	uint8 reserved() const { return reserved_; }
	uint32 context_id() const { return context_id_; }
	bytestring const & blob() const { return blob_; }
	DCE_RPC_Header * header() const { return header_; }
	int proc() const { return proc_; }
	
protected:
	uint8 type_;
	uint8 level_;
	uint8 pad_len_;
	uint8 reserved_;
	uint32 context_id_;
	bytestring blob_;
	DCE_RPC_Header * header_;
	int proc_;
};


class DCE_RPC_Flow final : public binpac::FlowAnalyzer
{
public:
	DCE_RPC_Flow(DCE_RPC_Conn * connection, bool is_orig);
	~DCE_RPC_Flow();
	
	// Member access functions
	FlowBuffer * flow_buffer() const { return flow_buffer_; }
	DCE_RPC_Conn * connection() const { return connection_; }
	bool is_orig() const { return is_orig_; }
	
	void NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data);
	void NewGap(int gap_length);
	void FlowEOF();
	
	// Functions
	bool reassemble_fragment(DCE_RPC_Header * header, bytestring const & frag);
	const_bytestring reassembled_body(DCE_RPC_Header * h, bytestring const & body);
	
protected:
	DCE_RPC_PDU * dataunit_;
	ContextDCE_RPC * context_;
	
	// Additional members

		std::map<uint32, std::unique_ptr<FlowBuffer>> fb;
	
	FlowBuffer * flow_buffer_;
	DCE_RPC_Conn * connection_;
	bool is_orig_;
};


class ATSVC_Request final
{
public:
	ATSVC_Request(bool unicode, uint8 opnum);
	~ATSVC_Request();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint8 op_case_index() const	{ return op_case_index_; }
	ATSVC_NetrJobAdd * add() const
		{
		switch ( op_case_index() )
			{
			case ((uint8) 0):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/dce-rpc/endpoint-atsvc.pac:5:add", (int64)op_case_index(), "((int) 0)");
				break;
			}
		return add_;
		}
	bytestring const & unknown() const
		{
		return unknown_;
		}
	bool unicode() const { return unicode_; }
	uint8 opnum() const { return opnum_; }
	
protected:
	uint8 op_case_index_;
	ATSVC_NetrJobAdd * add_;
	bytestring unknown_;
	bool unicode_;
	uint8 opnum_;
};


class ATSVC_String_Pointer final
{
public:
	ATSVC_String_Pointer(bool unicode);
	~ATSVC_String_Pointer();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 referent_id() const { return referent_id_; }
	uint32 max_count() const { return max_count_; }
	uint32 offset() const { return offset_; }
	uint32 actual_count() const { return actual_count_; }
	bytestring const & string() const { return string_; }
	bool unicode() const { return unicode_; }
	
protected:
	uint32 referent_id_;
	uint32 max_count_;
	uint32 offset_;
	uint32 actual_count_;
	bytestring string_;
	bool unicode_;
};


class ATSVC_NetrJobAdd final
{
public:
	ATSVC_NetrJobAdd(bool unicode);
	~ATSVC_NetrJobAdd();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	ATSVC_String_Pointer * server() const { return server_; }
	uint32 job_time() const { return job_time_; }
	uint32 days_of_month() const { return days_of_month_; }
	uint8 days_of_week() const { return days_of_week_; }
	uint8 flags() const { return flags_; }
	ATSVC_String_Pointer * command() const { return command_; }
	bool unicode() const { return unicode_; }
	
protected:
	ATSVC_String_Pointer * server_;
	uint32 job_time_;
	uint32 days_of_month_;
	uint8 days_of_week_;
	uint8 flags_;
	ATSVC_String_Pointer * command_;
	bool unicode_;
};


class ATSVC_Reply final
{
public:
	ATSVC_Reply(bool unicode, uint16 opnum);
	~ATSVC_Reply();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint16 op_case_index() const	{ return op_case_index_; }
	ATSVC_JobID * add() const
		{
		switch ( op_case_index() )
			{
			case ((uint16) 0):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/dce-rpc/endpoint-atsvc.pac:31:add", (int64)op_case_index(), "((int) 0)");
				break;
			}
		return add_;
		}
	bytestring const & unknown() const
		{
		return unknown_;
		}
	bool unicode() const { return unicode_; }
	uint16 opnum() const { return opnum_; }
	
protected:
	uint16 op_case_index_;
	ATSVC_JobID * add_;
	bytestring unknown_;
	bool unicode_;
	uint16 opnum_;
};


class ATSVC_JobID final
{
public:
	ATSVC_JobID(bool unicode);
	~ATSVC_JobID();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 id() const { return id_; }
	uint32 status() const { return status_; }
	bool unicode() const { return unicode_; }
	
protected:
	uint32 id_;
	uint32 status_;
	bool unicode_;
};


class epmapper_lookup_req final
{
public:
	epmapper_lookup_req();
	~epmapper_lookup_req();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 inquiry_type() const { return inquiry_type_; }
	uint32 object() const { return object_; }
	uint32 interface_id() const { return interface_id_; }
	uint32 vers_option() const { return vers_option_; }
	context_handle * entry_handle() const { return entry_handle_; }
	
protected:
	uint32 inquiry_type_;
	uint32 object_;
	uint32 interface_id_;
	uint32 vers_option_;
	context_handle * entry_handle_;
};


class epmapper_map_req final
{
public:
	epmapper_map_req();
	~epmapper_map_req();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	
protected:
};


class epm_uuid final
{
public:
	epm_uuid();
	~epm_uuid();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	bytestring const & if_uuid() const { return if_uuid_; }
	uint16 if_version() const { return if_version_; }
	int byteorder() const { return byteorder_; }
	
protected:
	bytestring if_uuid_;
	uint16 if_version_;
	int byteorder_;
};


class epm_port final
{
public:
	epm_port();
	~epm_port();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint16 val() const { return val_; }
	int byteorder() const { return byteorder_; }
	
protected:
	uint16 val_;
	int byteorder_;
};


class epm_ip final
{
public:
	epm_ip();
	~epm_ip();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint32 val() const { return val_; }
	int byteorder() const { return byteorder_; }
	
protected:
	uint32 val_;
	int byteorder_;
};


class epm_lhs_data final
{
public:
	epm_lhs_data(uint16 length, uint8 protocol);
	~epm_lhs_data();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint8 val_case_index() const	{ return val_case_index_; }
	epm_uuid * uuid() const
		{
		switch ( val_case_index() )
			{
			case ((uint8) 13):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/dce-rpc/endpoint-epmapper.pac:30:uuid", (int64)val_case_index(), "EPM_PROTOCOL_UUID");
				break;
			}
		return uuid_;
		}
	bytestring const & other() const
		{
		return other_;
		}
	uint16 length() const { return length_; }
	uint8 protocol() const { return protocol_; }
	
protected:
	uint8 val_case_index_;
	epm_uuid * uuid_;
	bytestring other_;
	uint16 length_;
	uint8 protocol_;
};


class epm_rhs_data final
{
public:
	epm_rhs_data(uint16 length, uint8 protocol);
	~epm_rhs_data();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint8 val_case_index() const	{ return val_case_index_; }
	uint16 tcp() const
		{
		switch ( val_case_index() )
			{
			case ((uint8) 7):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/dce-rpc/endpoint-epmapper.pac:35:tcp", (int64)val_case_index(), "EPM_PROTOCOL_TCP");
				break;
			}
		return tcp_;
		}
	uint16 udp() const
		{
		switch ( val_case_index() )
			{
			case ((uint8) 8):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/dce-rpc/endpoint-epmapper.pac:36:udp", (int64)val_case_index(), "EPM_PROTOCOL_UDP");
				break;
			}
		return udp_;
		}
	uint32 ip() const
		{
		switch ( val_case_index() )
			{
			case ((uint8) 9):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/dce-rpc/endpoint-epmapper.pac:37:ip", (int64)val_case_index(), "EPM_PROTOCOL_IP");
				break;
			}
		return ip_;
		}
	bytestring const & other() const
		{
		return other_;
		}
	uint16 length() const { return length_; }
	uint8 protocol() const { return protocol_; }
	
protected:
	uint8 val_case_index_;
	uint16 tcp_;
	uint16 udp_;
	uint32 ip_;
	bytestring other_;
	uint16 length_;
	uint8 protocol_;
};


class epm_lhs final
{
public:
	epm_lhs();
	~epm_lhs();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint16 length() const { return length_; }
	uint8 protocol() const { return protocol_; }
	epm_lhs_data * data() const { return data_; }
	int byteorder() const { return byteorder_; }
	
protected:
	uint16 length_;
	uint8 protocol_;
	epm_lhs_data * data_;
	int byteorder_;
};


class epm_rhs final
{
public:
	epm_rhs(uint8 protocol);
	~epm_rhs();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint16 length() const { return length_; }
	epm_rhs_data * data() const { return data_; }
	uint8 protocol() const { return protocol_; }
	int byteorder() const { return byteorder_; }
	
protected:
	uint16 length_;
	epm_rhs_data * data_;
	uint8 protocol_;
	int byteorder_;
};


class epm_floor final
{
public:
	epm_floor();
	~epm_floor();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	epm_lhs * lhs() const { return lhs_; }
	epm_rhs * rhs() const { return rhs_; }
	uint8 protocol() const { return protocol_; }
	
protected:
	epm_lhs * lhs_;
	epm_rhs * rhs_;
	uint8 protocol_;
};


class epm_tower final
{
public:
	epm_tower();
	~epm_tower();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint16 num_floors() const { return num_floors_; }
	vector<epm_floor *> * floors() const { return floors_; }
	int byteorder() const { return byteorder_; }
	
protected:
	uint16 num_floors_;
	vector<epm_floor *> * floors_;
	epm_floor * floors__elem_;
	int byteorder_;
};


class epm_twr_p final
{
public:
	epm_twr_p();
	~epm_twr_p();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 ref() const { return ref_; }
	uint32 length() const { return length_; }
	uint32 tower_length() const { return tower_length_; }
	epm_tower * tower() const { return tower_; }
	
protected:
	uint32 ref_;
	uint32 length_;
	uint32 tower_length_;
	epm_tower * tower_;
};


class epm_tower_array final
{
public:
	epm_tower_array();
	~epm_tower_array();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 max_count() const { return max_count_; }
	uint32 offset() const { return offset_; }
	uint32 actual_count() const { return actual_count_; }
	vector<epm_twr_p *> * towers() const { return towers_; }
	
protected:
	uint32 max_count_;
	uint32 offset_;
	uint32 actual_count_;
	vector<epm_twr_p *> * towers_;
	epm_twr_p * towers__elem_;
};


class epmapper_map_resp final
{
public:
	epmapper_map_resp();
	~epmapper_map_resp();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	context_handle * entry_handle() const { return entry_handle_; }
	uint32 num_towers() const { return num_towers_; }
	epm_tower_array * towers() const { return towers_; }
	uint32 return_code() const { return return_code_; }
	
protected:
	context_handle * entry_handle_;
	uint32 num_towers_;
	epm_tower_array * towers_;
	uint32 return_code_;
};

} // namespace DCE_RPC
}  // namespace binpac
#endif /* _builddir_build_BUILD_zeek_6_0_4_build_zeek_6_0_4_src_analyzer_protocol_dce_rpc_dce_rpc_pac_h */
