// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/dns/events.bif (plugin mode).


#include "events.bif.h"
#include "zeek/Func.h"

zeek::EventHandlerPtr dns_message; 
void zeek::BifEvent::enqueue_dns_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::Val> msg, zeek_uint_t len)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(msg),
	        zeek::val_mgr->Count(len),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_request; 
void zeek::BifEvent::enqueue_dns_request(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::StringVal> query, zeek_uint_t qtype, zeek_uint_t qclass, zeek::IntrusivePtr<zeek::StringVal> original_query)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_request is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_request is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_request, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(query),
	        zeek::val_mgr->Count(qtype),
	        zeek::val_mgr->Count(qclass),
	        std::move(original_query),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_rejected; 
void zeek::BifEvent::enqueue_dns_rejected(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::StringVal> query, zeek_uint_t qtype, zeek_uint_t qclass, zeek::IntrusivePtr<zeek::StringVal> original_query)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_rejected is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_rejected is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_rejected, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(query),
	        zeek::val_mgr->Count(qtype),
	        zeek::val_mgr->Count(qclass),
	        std::move(original_query),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_query_reply; 
void zeek::BifEvent::enqueue_dns_query_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::StringVal> query, zeek_uint_t qtype, zeek_uint_t qclass, zeek::IntrusivePtr<zeek::StringVal> original_query)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_query_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_query_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_query_reply, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(query),
	        zeek::val_mgr->Count(qtype),
	        zeek::val_mgr->Count(qclass),
	        std::move(original_query),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_A_reply; 
void zeek::BifEvent::enqueue_dns_A_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::AddrVal> a)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_A_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_A_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_A_reply, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(a),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_AAAA_reply; 
void zeek::BifEvent::enqueue_dns_AAAA_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::AddrVal> a)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_AAAA_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_AAAA_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_AAAA_reply, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(a),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_A6_reply; 
void zeek::BifEvent::enqueue_dns_A6_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::AddrVal> a)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_A6_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_A6_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_A6_reply, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(a),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_NS_reply; 
void zeek::BifEvent::enqueue_dns_NS_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::StringVal> name)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_NS_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_NS_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_NS_reply, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(name),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_CNAME_reply; 
void zeek::BifEvent::enqueue_dns_CNAME_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::StringVal> name)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_CNAME_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_CNAME_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_CNAME_reply, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(name),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_PTR_reply; 
void zeek::BifEvent::enqueue_dns_PTR_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::StringVal> name)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_PTR_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_PTR_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_PTR_reply, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(name),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_SOA_reply; 
void zeek::BifEvent::enqueue_dns_SOA_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::Val> soa)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_SOA_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_SOA_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_SOA_reply, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(soa),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_WKS_reply; 
void zeek::BifEvent::enqueue_dns_WKS_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_WKS_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_WKS_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_WKS_reply, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_HINFO_reply; 
void zeek::BifEvent::enqueue_dns_HINFO_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::StringVal> cpu, zeek::IntrusivePtr<zeek::StringVal> os)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_HINFO_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_HINFO_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_HINFO_reply, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(cpu),
	        std::move(os),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

 zeek::EventHandlerPtr dns_MX_reply; 
void zeek::BifEvent::enqueue_dns_MX_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::StringVal> name, zeek_uint_t preference)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_MX_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_MX_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_MX_reply, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(name),
	        zeek::val_mgr->Count(preference),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_TXT_reply; 
void zeek::BifEvent::enqueue_dns_TXT_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::Val> strs)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_TXT_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_TXT_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_TXT_reply, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(strs),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_SPF_reply; 
void zeek::BifEvent::enqueue_dns_SPF_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::Val> strs)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_SPF_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_SPF_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_SPF_reply, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(strs),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_CAA_reply; 
void zeek::BifEvent::enqueue_dns_CAA_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek_uint_t flags, zeek::IntrusivePtr<zeek::StringVal> tag, zeek::IntrusivePtr<zeek::StringVal> value)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_CAA_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_CAA_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_CAA_reply, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        zeek::val_mgr->Count(flags),
	        std::move(tag),
	        std::move(value),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_SRV_reply; 
void zeek::BifEvent::enqueue_dns_SRV_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::StringVal> target, zeek_uint_t priority, zeek_uint_t weight, zeek_uint_t p)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_SRV_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_SRV_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_SRV_reply, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(target),
	        zeek::val_mgr->Count(priority),
	        zeek::val_mgr->Count(weight),
	        zeek::val_mgr->Count(p),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_unknown_reply; 
void zeek::BifEvent::enqueue_dns_unknown_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_unknown_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_unknown_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_unknown_reply, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_EDNS_addl; 
void zeek::BifEvent::enqueue_dns_EDNS_addl(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_EDNS_addl is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_EDNS_addl is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_EDNS_addl, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_EDNS_ecs; 
void zeek::BifEvent::enqueue_dns_EDNS_ecs(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> opt)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_EDNS_ecs is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_EDNS_ecs is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_EDNS_ecs, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(opt),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_EDNS_tcp_keepalive; 
void zeek::BifEvent::enqueue_dns_EDNS_tcp_keepalive(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> opt)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_EDNS_tcp_keepalive is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_EDNS_tcp_keepalive is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_EDNS_tcp_keepalive, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(opt),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_EDNS_cookie; 
void zeek::BifEvent::enqueue_dns_EDNS_cookie(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> opt)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_EDNS_cookie is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_EDNS_cookie is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_EDNS_cookie, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(opt),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_TSIG_addl; 
void zeek::BifEvent::enqueue_dns_TSIG_addl(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_TSIG_addl is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_TSIG_addl is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_TSIG_addl, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_RRSIG; 
void zeek::BifEvent::enqueue_dns_RRSIG(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::Val> rrsig)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_RRSIG is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_RRSIG is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_RRSIG, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(rrsig),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_DNSKEY; 
void zeek::BifEvent::enqueue_dns_DNSKEY(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::Val> dnskey)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_DNSKEY is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_DNSKEY is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_DNSKEY, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(dnskey),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_NSEC; 
void zeek::BifEvent::enqueue_dns_NSEC(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::StringVal> next_name, zeek::IntrusivePtr<zeek::Val> bitmaps)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_NSEC is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_NSEC is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_NSEC, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(next_name),
	        std::move(bitmaps),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_NSEC3; 
void zeek::BifEvent::enqueue_dns_NSEC3(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::Val> nsec3)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_NSEC3 is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_NSEC3 is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_NSEC3, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(nsec3),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_NSEC3PARAM; 
void zeek::BifEvent::enqueue_dns_NSEC3PARAM(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::Val> nsec3param)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_NSEC3PARAM is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_NSEC3PARAM is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_NSEC3PARAM, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(nsec3param),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_DS; 
void zeek::BifEvent::enqueue_dns_DS(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::Val> ds)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_DS is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_DS is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_DS, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(ds),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_BINDS; 
void zeek::BifEvent::enqueue_dns_BINDS(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::Val> binds)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_BINDS is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_BINDS is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_BINDS, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(binds),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_SSHFP; 
void zeek::BifEvent::enqueue_dns_SSHFP(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek_uint_t algo, zeek_uint_t fptype, zeek::IntrusivePtr<zeek::StringVal> fingerprint)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_SSHFP is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_SSHFP is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_SSHFP, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        zeek::val_mgr->Count(algo),
	        zeek::val_mgr->Count(fptype),
	        std::move(fingerprint),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_LOC; 
void zeek::BifEvent::enqueue_dns_LOC(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::Val> loc)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_LOC is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_LOC is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_LOC, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(loc),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_SVCB; 
void zeek::BifEvent::enqueue_dns_SVCB(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::Val> svcb)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_SVCB is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_SVCB is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_SVCB, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(svcb),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_HTTPS; 
void zeek::BifEvent::enqueue_dns_HTTPS(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg, zeek::IntrusivePtr<zeek::Val> ans, zeek::IntrusivePtr<zeek::Val> https)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_HTTPS is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_HTTPS is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_HTTPS, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(ans),
	        std::move(https),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr dns_end; 
void zeek::BifEvent::enqueue_dns_end(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> msg)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_end is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_dns_end is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::dns_end, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

