// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif (plugin mode).


#include "functions.bif.h"
#include "zeek/Func.h"

namespace zeek { namespace BifType { namespace Record{  zeek::IntrusivePtr<zeek::RecordType> ftp_port;  } }}
namespace BifType { namespace Record{  zeek::RecordType * ftp_port;  } }

#line 4 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"

#include "zeek/Reporter.h"

static zeek::ValPtr parse_port(const char* line)
	{
	auto r = zeek::make_intrusive<zeek::RecordVal>(zeek::BifType::Record::ftp_port);

	int bytes[6];
	if ( line && sscanf(line, "%d,%d,%d,%d,%d,%d",
			&bytes[0], &bytes[1], &bytes[2],
			&bytes[3], &bytes[4], &bytes[5]) == 6 )
		{
		int good = 1;

		for ( int i = 0; i < 6; ++i )
			if ( bytes[i] < 0 || bytes[i] > 255 )
				{
				good = 0;
				break;
				}

		uint32_t addr = (bytes[0] << 24) | (bytes[1] << 16) |
				(bytes[2] << 8) | bytes[3];
		uint32_t port = (bytes[4] << 8) | bytes[5];

		// Since port is unsigned, no need to check for < 0.
		if ( port > 65535 )
			{
			port = 0;
			good = 0;
			}

		r->Assign(0, zeek::make_intrusive<zeek::AddrVal>(htonl(addr)));
		r->Assign(1, zeek::val_mgr->Port(port, TRANSPORT_TCP));
		r->Assign(2, good);
		}
	else
		{
		r->Assign(0, zeek::make_intrusive<zeek::AddrVal>(uint32_t(0)));
		r->Assign(1, zeek::val_mgr->Port(0, TRANSPORT_TCP));
		r->Assign(2, false);
		}

	return r;
	}

static zeek::ValPtr parse_eftp(const char* line)
	{
	auto r = zeek::make_intrusive<zeek::RecordVal>(zeek::BifType::Record::ftp_port);

	int net_proto = 0;	// currently not used
	zeek::IPAddr addr;	// unspecified IPv6 address (all 128 bits zero)
	int port = 0;
	int good = 0;

	if ( line )
		{
		while ( isspace(*line) )	// skip whitespace
			++line;

		char delimiter = *line;
		char* next_delim;

		if ( *line )
			{
			good = 1;
			++line;	// skip delimiter

			net_proto = strtol(line, &next_delim, 10);
			if ( *next_delim != delimiter )
				good = 0;

			line = next_delim;
			if ( *line )
				++line;

			if ( *line && *line != delimiter )
				{
				const char* nptr = strchr(line, delimiter);
				if ( nptr == NULL )
					{
					nptr = line + strlen(line);
					good = 0;
					}

				std::string s(line, nptr-line); // extract IP address
				struct in6_addr result;
				good = zeek::IPAddr::ConvertString(s.c_str(), &result) ? 1 : 0;
				if ( good )
					addr = zeek::IPAddr(result);
				}

			line = strchr(line, delimiter);

			if ( line != NULL )
				{
				++line;	// now the port
				port = strtol(line, &next_delim, 10);
				if ( *next_delim != delimiter )
					good = 0;

				if ( port < 0 || port > 65535 )
					{
					port = 0;
					good = 0;
					}
				}
			}

		}

	r->Assign(0, zeek::make_intrusive<zeek::AddrVal>(addr));
	r->Assign(1, zeek::val_mgr->Port(port, TRANSPORT_TCP));
	r->Assign(2, good);

	return r;
	}

#line 131 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::parse_ftp_port_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 132 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("parse_ftp_port() takes exactly 1 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::StringVal* s = (zeek::StringVal*) ((*BiF_ARGS)[0].get()->AsStringVal());

#line 132 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"

	return parse_port(s->CheckString());
	} // end of BifFunc::parse_ftp_port

#line 134 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"

#line 146 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::parse_eftp_port_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 147 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("parse_eftp_port() takes exactly 1 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::StringVal* s = (zeek::StringVal*) ((*BiF_ARGS)[0].get()->AsStringVal());

#line 147 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"

	return parse_eftp(s->CheckString());
	} // end of BifFunc::parse_eftp_port

#line 149 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"

#line 158 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::parse_ftp_pasv_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 159 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("parse_ftp_pasv() takes exactly 1 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::StringVal* str = (zeek::StringVal*) ((*BiF_ARGS)[0].get()->AsStringVal());

#line 159 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"

	const char* s = str->CheckString();
	const char* line = strchr(s, '(');
	if ( line )
		++line;	// move past '('
	else if ( (line = strstr(s, "PORT")) )
		line += 5;	// Skip over
	else if ( (line = strchr(s, ',')) )
		{ // Look for comma-separated list.
		while ( --line >= s && isdigit(*line) )
			;	// Back up over preceding digits.
		++line;	// now points to first digit, or beginning of s
		}

	return parse_port(line);
	} // end of BifFunc::parse_ftp_pasv

#line 174 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"

#line 185 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::parse_ftp_epsv_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 186 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("parse_ftp_epsv() takes exactly 1 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::StringVal* str = (zeek::StringVal*) ((*BiF_ARGS)[0].get()->AsStringVal());

#line 186 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"

	const char* s = str->CheckString();
	const char* line = strchr(s, '(');
	if ( line )
		++line; // move past '('
	return parse_eftp(line);
	} // end of BifFunc::parse_ftp_epsv

#line 192 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"

#line 204 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::fmt_ftp_port_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 205 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("fmt_ftp_port() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::AddrVal* a = (zeek::AddrVal*) ((*BiF_ARGS)[0].get()->AsAddrVal());
	zeek::PortVal* p = (zeek::PortVal*) ((*BiF_ARGS)[1].get()->AsPortVal());

#line 205 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"

	const uint32_t* addr;
	int len = a->AsAddr().GetBytes(&addr);
	if ( len == 1 )
		{
		uint32_t a = ntohl(addr[0]);
		uint32_t pn = p->Port();
		return zeek::make_intrusive<zeek::StringVal>(zeek::util::fmt("%d,%d,%d,%d,%d,%d",
		                                                 a >> 24, (a >> 16) & 0xff,
		                                                 (a >> 8) & 0xff, a & 0xff,
		                                                 pn >> 8, pn & 0xff));
		}
	else
		{
		zeek::emit_builtin_error("conversion of non-IPv4 address in fmt_ftp_port",
		                         (*BiF_ARGS)[0]);
		return zeek::val_mgr->EmptyString();
		}
	} // end of BifFunc::fmt_ftp_port

#line 223 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ftp/functions.bif"
