// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/http/events.bif (plugin mode).


#include "events.bif.h"
#include "zeek/Func.h"

zeek::EventHandlerPtr http_request; 
void zeek::BifEvent::enqueue_http_request(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> method, zeek::IntrusivePtr<zeek::StringVal> original_URI, zeek::IntrusivePtr<zeek::StringVal> unescaped_URI, zeek::IntrusivePtr<zeek::StringVal> version)
	{
	// Note that it is intentional that here we do not
	// check if ::http_request is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_http_request is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::http_request, zeek::Args{
	        c->GetVal(),
	        std::move(method),
	        std::move(original_URI),
	        std::move(unescaped_URI),
	        std::move(version),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr http_reply; 
void zeek::BifEvent::enqueue_http_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> version, zeek_uint_t code, zeek::IntrusivePtr<zeek::StringVal> reason)
	{
	// Note that it is intentional that here we do not
	// check if ::http_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_http_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::http_reply, zeek::Args{
	        c->GetVal(),
	        std::move(version),
	        zeek::val_mgr->Count(code),
	        std::move(reason),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr http_header; 
void zeek::BifEvent::enqueue_http_header(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> original_name, zeek::IntrusivePtr<zeek::StringVal> name, zeek::IntrusivePtr<zeek::StringVal> value)
	{
	// Note that it is intentional that here we do not
	// check if ::http_header is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_http_header is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::http_header, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(original_name),
	        std::move(name),
	        std::move(value),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr http_all_headers; 
void zeek::BifEvent::enqueue_http_all_headers(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::Val> hlist)
	{
	// Note that it is intentional that here we do not
	// check if ::http_all_headers is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_http_all_headers is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::http_all_headers, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(hlist),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr http_begin_entity; 
void zeek::BifEvent::enqueue_http_begin_entity(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig)
	{
	// Note that it is intentional that here we do not
	// check if ::http_begin_entity is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_http_begin_entity is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::http_begin_entity, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr http_end_entity; 
void zeek::BifEvent::enqueue_http_end_entity(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig)
	{
	// Note that it is intentional that here we do not
	// check if ::http_end_entity is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_http_end_entity is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::http_end_entity, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr http_entity_data; 
void zeek::BifEvent::enqueue_http_entity_data(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek_uint_t length, zeek::IntrusivePtr<zeek::StringVal> data)
	{
	// Note that it is intentional that here we do not
	// check if ::http_entity_data is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_http_entity_data is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::http_entity_data, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        zeek::val_mgr->Count(length),
	        std::move(data),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr http_content_type; 
void zeek::BifEvent::enqueue_http_content_type(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> ty, zeek::IntrusivePtr<zeek::StringVal> subty)
	{
	// Note that it is intentional that here we do not
	// check if ::http_content_type is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_http_content_type is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::http_content_type, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(ty),
	        std::move(subty),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr http_message_done; 
void zeek::BifEvent::enqueue_http_message_done(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::Val> stat)
	{
	// Note that it is intentional that here we do not
	// check if ::http_message_done is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_http_message_done is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::http_message_done, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(stat),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr http_event; 
void zeek::BifEvent::enqueue_http_event(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> event_type, zeek::IntrusivePtr<zeek::StringVal> detail)
	{
	// Note that it is intentional that here we do not
	// check if ::http_event is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_http_event is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::http_event, zeek::Args{
	        c->GetVal(),
	        std::move(event_type),
	        std::move(detail),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr http_stats; 
void zeek::BifEvent::enqueue_http_stats(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> stats)
	{
	// Note that it is intentional that here we do not
	// check if ::http_stats is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_http_stats is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::http_stats, zeek::Args{
	        c->GetVal(),
	        std::move(stats),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr http_connection_upgrade; 
void zeek::BifEvent::enqueue_http_connection_upgrade(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> protocol)
	{
	// Note that it is intentional that here we do not
	// check if ::http_connection_upgrade is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_http_connection_upgrade is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::http_connection_upgrade, zeek::Args{
	        c->GetVal(),
	        std::move(protocol),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

