// This file is automatically generated from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/imap/imap.pac.

#ifndef _builddir_build_BUILD_zeek_6_0_4_build_zeek_6_0_4_src_analyzer_protocol_imap_imap_pac_h
#define _builddir_build_BUILD_zeek_6_0_4_build_zeek_6_0_4_src_analyzer_protocol_imap_imap_pac_h

#include <vector>

#include "binpac.h"


#include "zeek/binpac_zeek.h"



namespace zeek::analyzer::imap { class IMAP_Analyzer; }
namespace binpac { namespace IMAP { class IMAP_Conn; } }
using IMAPAnalyzer = zeek::analyzer::imap::IMAP_Analyzer*;

#include "zeek/zeek-config.h"
#include "zeek/Reporter.h"
#include "zeek/analyzer/protocol/imap/IMAP.h"

#include "zeek/analyzer/protocol/imap/events.bif.h"


namespace binpac {

namespace IMAP {
class ContextIMAP;
class IMAP_Conn;
enum ImapCommand {
	CMD_CAPABILITY,
	CMD_UNKNOWN,
};
extern RegExMatcher TAG_re_001;

class TAG;
extern RegExMatcher CONTENT_re_002;

class CONTENT;
extern RegExMatcher SPACING_re_003;

class SPACING;
extern RegExMatcher OPTIONALSPACING_re_004;

class OPTIONALSPACING;
extern RegExMatcher NEWLINE_re_005;

class NEWLINE;
extern RegExMatcher OPTIONALNEWLINE_re_006;

class OPTIONALNEWLINE;
class IMAP_PDU;
class ImapToken;
class ServerContentText;
class Capability;
class ServerCapability;
class UnknownCommand;
class IMAP_Flow;
} // namespace IMAP

int bytestring_to_int(const_bytestring const & s, int base);
double bytestring_to_double(const_bytestring const & s);
int bytestring_casecmp(const_bytestring const & s1, const_charptr const & s2);
bool bytestring_caseprefix(const_bytestring const & s1, const_charptr const & s2);
double network_time();
namespace IMAP {

class ContextIMAP final
{
public:
	ContextIMAP(IMAP_Conn * connection, IMAP_Flow * flow);
	~ContextIMAP();
	
	// Member access functions
	IMAP_Conn * connection() const { return connection_; }
	IMAP_Flow * flow() const { return flow_; }
	
protected:
	IMAP_Conn * connection_;
	IMAP_Flow * flow_;
};


class IMAP_Conn final : public binpac::ConnectionAnalyzer
{
public:
	IMAP_Conn(IMAPAnalyzer const & zeek_analyzer);
	~IMAP_Conn();
	
	// Member access functions
	IMAP_Flow * upflow() const { return upflow_; }
	IMAP_Flow * downflow() const { return downflow_; }
	IMAPAnalyzer const & zeek_analyzer() const { return zeek_analyzer_; }
	
	void NewData(bool is_orig, const_byteptr begin, const_byteptr end);
	void NewGap(bool is_orig, int gap_length);
	void FlowEOF(bool is_orig);
	
	// Functions
	int determine_command(bool is_orig, bytestring const & tag, bytestring const & command);
	int strlen(bytestring const & str);
	bool proc_imap_token(bool is_orig, bytestring const & tag, bytestring const & command);
	bool proc_server_capability(vector<Capability *> * capabilities);
	
protected:
	
	// Additional members

		string client_starttls_id;
	
	IMAP_Flow * upflow_;
	IMAP_Flow * downflow_;
	IMAPAnalyzer zeek_analyzer_;
};


class IMAP_PDU final
{
public:
	IMAP_PDU(bool is_orig);
	~IMAP_PDU();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextIMAP * t_context);
	
	// Member access functions
	vector<ImapToken *> * val() const { return val_; }
	bool is_orig() const { return is_orig_; }
	int size() const	{ return val() ? val()->size() : 0; }
	ImapToken * operator[](int index) const { BINPAC_ASSERT(val()); return (*val())[index]; }
	
protected:
	vector<ImapToken *> * val_;
	bool is_orig_;
	ImapToken * val__elem_;
};


class ImapToken final
{
public:
	ImapToken(bool is_orig);
	~ImapToken();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextIMAP * t_context);
	
	// Member access functions
	bytestring const & tag() const { return tag_; }
	bytestring const & anonymous_field_007() const { return anonymous_field_007_; }
	bytestring const & command() const { return command_; }
	bytestring const & anonymous_field_008() const { return anonymous_field_008_; }
	int client_or_server_case_index() const	{ return client_or_server_case_index_; }
	UnknownCommand * client() const
		{
		switch ( client_or_server_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/imap/imap-protocol.pac:23:client", (int64)client_or_server_case_index(), "true");
				break;
			}
		return client_;
		}
	ServerContentText * server() const
		{
		switch ( client_or_server_case_index() )
			{
			case ((bool) 0):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/imap/imap-protocol.pac:24:server", (int64)client_or_server_case_index(), "false");
				break;
			}
		return server_;
		}
	bool is_orig() const { return is_orig_; }
	int pcommand() const { return pcommand_; }
	bool proc() const { return proc_; }
	
protected:
	bytestring tag_;
	bytestring anonymous_field_007_;
	bytestring command_;
	bytestring anonymous_field_008_;
	int client_or_server_case_index_;
	UnknownCommand * client_;
	ServerContentText * server_;
	bool is_orig_;
	int pcommand_;
	bool proc_;
};


class ServerContentText final
{
public:
	ServerContentText(ImapToken * rec);
	~ServerContentText();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextIMAP * t_context);
	
	// Member access functions
	int val_case_index() const	{ return val_case_index_; }
	ServerCapability * capability() const
		{
		switch ( val_case_index() )
			{
			case ((int) 0):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/imap/imap-protocol.pac:31:capability", (int64)val_case_index(), "CMD_CAPABILITY");
				break;
			}
		return capability_;
		}
	UnknownCommand * unknown() const
		{
		return unknown_;
		}
	ImapToken * rec() const { return rec_; }
	
protected:
	int val_case_index_;
	ServerCapability * capability_;
	UnknownCommand * unknown_;
	ImapToken * rec_;
};


class Capability final
{
public:
	Capability();
	~Capability();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	bytestring const & cap() const { return cap_; }
	bytestring const & anonymous_field_009() const { return anonymous_field_009_; }
	bytestring const & nl() const { return nl_; }
	
protected:
	bytestring cap_;
	bytestring anonymous_field_009_;
	bytestring nl_;
};


class ServerCapability final
{
public:
	ServerCapability(ImapToken * rec);
	~ServerCapability();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextIMAP * t_context);
	
	// Member access functions
	vector<Capability *> * capabilities() const { return capabilities_; }
	ImapToken * rec() const { return rec_; }
	bool proc() const { return proc_; }
	
protected:
	vector<Capability *> * capabilities_;
	Capability * capabilities__elem_;
	ImapToken * rec_;
	bool proc_;
};


class UnknownCommand final
{
public:
	UnknownCommand(ImapToken * rec);
	~UnknownCommand();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextIMAP * t_context);
	
	// Member access functions
	bytestring const & tagcontent() const { return tagcontent_; }
	bytestring const & anonymous_field_010() const { return anonymous_field_010_; }
	ImapToken * rec() const { return rec_; }
	
protected:
	bytestring tagcontent_;
	bytestring anonymous_field_010_;
	ImapToken * rec_;
};


class IMAP_Flow final : public binpac::FlowAnalyzer
{
public:
	IMAP_Flow(IMAP_Conn * connection, bool is_orig);
	~IMAP_Flow();
	
	// Member access functions
	IMAP_Conn * connection() const { return connection_; }
	bool is_orig() const { return is_orig_; }
	
	void NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data);
	void NewGap(int gap_length);
	void FlowEOF();
	
protected:
	IMAP_PDU * dataunit_;
	ContextIMAP * context_;
	IMAP_Conn * connection_;
	bool is_orig_;
};

} // namespace IMAP
}  // namespace binpac
#endif /* _builddir_build_BUILD_zeek_6_0_4_build_zeek_6_0_4_src_analyzer_protocol_imap_imap_pac_h */
