// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/irc/events.bif (plugin mode).


#include "events.bif.h"
#include "zeek/Func.h"

zeek::EventHandlerPtr irc_request; 
void zeek::BifEvent::enqueue_irc_request(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> prefix, zeek::IntrusivePtr<zeek::StringVal> command, zeek::IntrusivePtr<zeek::StringVal> arguments)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_request is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_request is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_request, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(prefix),
	        std::move(command),
	        std::move(arguments),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_reply; 
void zeek::BifEvent::enqueue_irc_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> prefix, zeek_uint_t code, zeek::IntrusivePtr<zeek::StringVal> params)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_reply, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(prefix),
	        zeek::val_mgr->Count(code),
	        std::move(params),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_message; 
void zeek::BifEvent::enqueue_irc_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> prefix, zeek::IntrusivePtr<zeek::StringVal> command, zeek::IntrusivePtr<zeek::StringVal> message)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(prefix),
	        std::move(command),
	        std::move(message),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_quit_message; 
void zeek::BifEvent::enqueue_irc_quit_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> nick, zeek::IntrusivePtr<zeek::StringVal> message)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_quit_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_quit_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_quit_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(nick),
	        std::move(message),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_privmsg_message; 
void zeek::BifEvent::enqueue_irc_privmsg_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> source, zeek::IntrusivePtr<zeek::StringVal> target, zeek::IntrusivePtr<zeek::StringVal> message)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_privmsg_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_privmsg_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_privmsg_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(source),
	        std::move(target),
	        std::move(message),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_notice_message; 
void zeek::BifEvent::enqueue_irc_notice_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> source, zeek::IntrusivePtr<zeek::StringVal> target, zeek::IntrusivePtr<zeek::StringVal> message)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_notice_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_notice_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_notice_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(source),
	        std::move(target),
	        std::move(message),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_squery_message; 
void zeek::BifEvent::enqueue_irc_squery_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> source, zeek::IntrusivePtr<zeek::StringVal> target, zeek::IntrusivePtr<zeek::StringVal> message)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_squery_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_squery_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_squery_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(source),
	        std::move(target),
	        std::move(message),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_join_message; 
void zeek::BifEvent::enqueue_irc_join_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::Val> info_list)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_join_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_join_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_join_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(info_list),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_part_message; 
void zeek::BifEvent::enqueue_irc_part_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> nick, zeek::IntrusivePtr<zeek::Val> chans, zeek::IntrusivePtr<zeek::StringVal> message)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_part_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_part_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_part_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(nick),
	        std::move(chans),
	        std::move(message),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_nick_message; 
void zeek::BifEvent::enqueue_irc_nick_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> who, zeek::IntrusivePtr<zeek::StringVal> newnick)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_nick_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_nick_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_nick_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(who),
	        std::move(newnick),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_invalid_nick; 
void zeek::BifEvent::enqueue_irc_invalid_nick(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_invalid_nick is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_invalid_nick is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_invalid_nick, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_network_info; 
void zeek::BifEvent::enqueue_irc_network_info(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek_uint_t users, zeek_uint_t services, zeek_uint_t servers)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_network_info is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_network_info is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_network_info, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        zeek::val_mgr->Count(users),
	        zeek::val_mgr->Count(services),
	        zeek::val_mgr->Count(servers),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_server_info; 
void zeek::BifEvent::enqueue_irc_server_info(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek_uint_t users, zeek_uint_t services, zeek_uint_t servers)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_server_info is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_server_info is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_server_info, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        zeek::val_mgr->Count(users),
	        zeek::val_mgr->Count(services),
	        zeek::val_mgr->Count(servers),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_channel_info; 
void zeek::BifEvent::enqueue_irc_channel_info(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek_uint_t chans)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_channel_info is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_channel_info is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_channel_info, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        zeek::val_mgr->Count(chans),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_who_line; 
void zeek::BifEvent::enqueue_irc_who_line(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> target_nick, zeek::IntrusivePtr<zeek::StringVal> channel, zeek::IntrusivePtr<zeek::StringVal> user, zeek::IntrusivePtr<zeek::StringVal> host, zeek::IntrusivePtr<zeek::StringVal> server, zeek::IntrusivePtr<zeek::StringVal> nick, zeek::IntrusivePtr<zeek::StringVal> params, zeek_uint_t hops, zeek::IntrusivePtr<zeek::StringVal> real_name)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_who_line is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_who_line is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_who_line, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(target_nick),
	        std::move(channel),
	        std::move(user),
	        std::move(host),
	        std::move(server),
	        std::move(nick),
	        std::move(params),
	        zeek::val_mgr->Count(hops),
	        std::move(real_name),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_names_info; 
void zeek::BifEvent::enqueue_irc_names_info(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> c_type, zeek::IntrusivePtr<zeek::StringVal> channel, zeek::IntrusivePtr<zeek::Val> users)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_names_info is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_names_info is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_names_info, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(c_type),
	        std::move(channel),
	        std::move(users),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_whois_operator_line; 
void zeek::BifEvent::enqueue_irc_whois_operator_line(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> nick)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_whois_operator_line is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_whois_operator_line is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_whois_operator_line, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(nick),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_whois_channel_line; 
void zeek::BifEvent::enqueue_irc_whois_channel_line(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> nick, zeek::IntrusivePtr<zeek::Val> chans)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_whois_channel_line is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_whois_channel_line is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_whois_channel_line, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(nick),
	        std::move(chans),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_whois_user_line; 
void zeek::BifEvent::enqueue_irc_whois_user_line(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> nick, zeek::IntrusivePtr<zeek::StringVal> user, zeek::IntrusivePtr<zeek::StringVal> host, zeek::IntrusivePtr<zeek::StringVal> real_name)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_whois_user_line is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_whois_user_line is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_whois_user_line, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(nick),
	        std::move(user),
	        std::move(host),
	        std::move(real_name),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_oper_response; 
void zeek::BifEvent::enqueue_irc_oper_response(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, int got_oper)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_oper_response is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_oper_response is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_oper_response, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        zeek::val_mgr->Bool(got_oper),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_global_users; 
void zeek::BifEvent::enqueue_irc_global_users(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> prefix, zeek::IntrusivePtr<zeek::StringVal> msg)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_global_users is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_global_users is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_global_users, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(prefix),
	        std::move(msg),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_channel_topic; 
void zeek::BifEvent::enqueue_irc_channel_topic(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> channel, zeek::IntrusivePtr<zeek::StringVal> topic)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_channel_topic is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_channel_topic is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_channel_topic, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(channel),
	        std::move(topic),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_who_message; 
void zeek::BifEvent::enqueue_irc_who_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> mask, int oper)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_who_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_who_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_who_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(mask),
	        zeek::val_mgr->Bool(oper),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_whois_message; 
void zeek::BifEvent::enqueue_irc_whois_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> server, zeek::IntrusivePtr<zeek::StringVal> users)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_whois_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_whois_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_whois_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(server),
	        std::move(users),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_oper_message; 
void zeek::BifEvent::enqueue_irc_oper_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> user, zeek::IntrusivePtr<zeek::StringVal> password)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_oper_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_oper_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_oper_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(user),
	        std::move(password),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_kick_message; 
void zeek::BifEvent::enqueue_irc_kick_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> prefix, zeek::IntrusivePtr<zeek::StringVal> chans, zeek::IntrusivePtr<zeek::StringVal> users, zeek::IntrusivePtr<zeek::StringVal> comment)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_kick_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_kick_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_kick_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(prefix),
	        std::move(chans),
	        std::move(users),
	        std::move(comment),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_error_message; 
void zeek::BifEvent::enqueue_irc_error_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> prefix, zeek::IntrusivePtr<zeek::StringVal> message)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_error_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_error_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_error_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(prefix),
	        std::move(message),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_invite_message; 
void zeek::BifEvent::enqueue_irc_invite_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> prefix, zeek::IntrusivePtr<zeek::StringVal> nickname, zeek::IntrusivePtr<zeek::StringVal> channel)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_invite_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_invite_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_invite_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(prefix),
	        std::move(nickname),
	        std::move(channel),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_mode_message; 
void zeek::BifEvent::enqueue_irc_mode_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> prefix, zeek::IntrusivePtr<zeek::StringVal> params)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_mode_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_mode_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_mode_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(prefix),
	        std::move(params),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_squit_message; 
void zeek::BifEvent::enqueue_irc_squit_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> prefix, zeek::IntrusivePtr<zeek::StringVal> server, zeek::IntrusivePtr<zeek::StringVal> message)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_squit_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_squit_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_squit_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(prefix),
	        std::move(server),
	        std::move(message),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_dcc_message; 
void zeek::BifEvent::enqueue_irc_dcc_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> prefix, zeek::IntrusivePtr<zeek::StringVal> target, zeek::IntrusivePtr<zeek::StringVal> dcc_type, zeek::IntrusivePtr<zeek::StringVal> argument, zeek::IntrusivePtr<zeek::AddrVal> address, zeek_uint_t dest_port, zeek_uint_t size)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_dcc_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_dcc_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_dcc_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(prefix),
	        std::move(target),
	        std::move(dcc_type),
	        std::move(argument),
	        std::move(address),
	        zeek::val_mgr->Count(dest_port),
	        zeek::val_mgr->Count(size),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_dcc_send_ack; 
void zeek::BifEvent::enqueue_irc_dcc_send_ack(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek_uint_t bytes_received)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_dcc_send_ack is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_dcc_send_ack is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_dcc_send_ack, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Count(bytes_received),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_user_message; 
void zeek::BifEvent::enqueue_irc_user_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> user, zeek::IntrusivePtr<zeek::StringVal> host, zeek::IntrusivePtr<zeek::StringVal> server, zeek::IntrusivePtr<zeek::StringVal> real_name)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_user_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_user_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_user_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(user),
	        std::move(host),
	        std::move(server),
	        std::move(real_name),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_password_message; 
void zeek::BifEvent::enqueue_irc_password_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> password)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_password_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_password_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_password_message, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(password),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr irc_starttls; 
void zeek::BifEvent::enqueue_irc_starttls(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_starttls is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_irc_starttls is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::irc_starttls, zeek::Args{
	        c->GetVal(),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

