// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/login/events.bif (plugin mode).


#include "events.bif.h"
#include "zeek/Func.h"

zeek::EventHandlerPtr rsh_request; 
void zeek::BifEvent::enqueue_rsh_request(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> client_user, zeek::IntrusivePtr<zeek::StringVal> server_user, zeek::IntrusivePtr<zeek::StringVal> line, int new_session)
	{
	// Note that it is intentional that here we do not
	// check if ::rsh_request is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rsh_request is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rsh_request, zeek::Args{
	        c->GetVal(),
	        std::move(client_user),
	        std::move(server_user),
	        std::move(line),
	        zeek::val_mgr->Bool(new_session),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr rsh_reply; 
void zeek::BifEvent::enqueue_rsh_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> client_user, zeek::IntrusivePtr<zeek::StringVal> server_user, zeek::IntrusivePtr<zeek::StringVal> line)
	{
	// Note that it is intentional that here we do not
	// check if ::rsh_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rsh_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rsh_reply, zeek::Args{
	        c->GetVal(),
	        std::move(client_user),
	        std::move(server_user),
	        std::move(line),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr login_failure; 
void zeek::BifEvent::enqueue_login_failure(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> user, zeek::IntrusivePtr<zeek::StringVal> client_user, zeek::IntrusivePtr<zeek::StringVal> password, zeek::IntrusivePtr<zeek::StringVal> line)
	{
	// Note that it is intentional that here we do not
	// check if ::login_failure is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_login_failure is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::login_failure, zeek::Args{
	        c->GetVal(),
	        std::move(user),
	        std::move(client_user),
	        std::move(password),
	        std::move(line),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr login_success; 
void zeek::BifEvent::enqueue_login_success(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> user, zeek::IntrusivePtr<zeek::StringVal> client_user, zeek::IntrusivePtr<zeek::StringVal> password, zeek::IntrusivePtr<zeek::StringVal> line)
	{
	// Note that it is intentional that here we do not
	// check if ::login_success is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_login_success is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::login_success, zeek::Args{
	        c->GetVal(),
	        std::move(user),
	        std::move(client_user),
	        std::move(password),
	        std::move(line),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr login_input_line; 
void zeek::BifEvent::enqueue_login_input_line(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> line)
	{
	// Note that it is intentional that here we do not
	// check if ::login_input_line is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_login_input_line is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::login_input_line, zeek::Args{
	        c->GetVal(),
	        std::move(line),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr login_output_line; 
void zeek::BifEvent::enqueue_login_output_line(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> line)
	{
	// Note that it is intentional that here we do not
	// check if ::login_output_line is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_login_output_line is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::login_output_line, zeek::Args{
	        c->GetVal(),
	        std::move(line),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr login_confused; 
void zeek::BifEvent::enqueue_login_confused(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> msg, zeek::IntrusivePtr<zeek::StringVal> line)
	{
	// Note that it is intentional that here we do not
	// check if ::login_confused is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_login_confused is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::login_confused, zeek::Args{
	        c->GetVal(),
	        std::move(msg),
	        std::move(line),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr login_confused_text; 
void zeek::BifEvent::enqueue_login_confused_text(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> line)
	{
	// Note that it is intentional that here we do not
	// check if ::login_confused_text is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_login_confused_text is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::login_confused_text, zeek::Args{
	        c->GetVal(),
	        std::move(line),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr login_terminal; 
void zeek::BifEvent::enqueue_login_terminal(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> terminal)
	{
	// Note that it is intentional that here we do not
	// check if ::login_terminal is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_login_terminal is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::login_terminal, zeek::Args{
	        c->GetVal(),
	        std::move(terminal),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr login_display; 
void zeek::BifEvent::enqueue_login_display(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> display)
	{
	// Note that it is intentional that here we do not
	// check if ::login_display is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_login_display is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::login_display, zeek::Args{
	        c->GetVal(),
	        std::move(display),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr authentication_accepted; 
void zeek::BifEvent::enqueue_authentication_accepted(zeek::analyzer::Analyzer* analyzer, zeek::IntrusivePtr<zeek::StringVal> name, zeek::Connection* c)
	{
	// Note that it is intentional that here we do not
	// check if ::authentication_accepted is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_authentication_accepted is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::authentication_accepted, zeek::Args{
	        std::move(name),
	        c->GetVal(),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr authentication_rejected; 
void zeek::BifEvent::enqueue_authentication_rejected(zeek::analyzer::Analyzer* analyzer, zeek::IntrusivePtr<zeek::StringVal> name, zeek::Connection* c)
	{
	// Note that it is intentional that here we do not
	// check if ::authentication_rejected is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_authentication_rejected is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::authentication_rejected, zeek::Args{
	        std::move(name),
	        c->GetVal(),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr authentication_skipped; 
void zeek::BifEvent::enqueue_authentication_skipped(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c)
	{
	// Note that it is intentional that here we do not
	// check if ::authentication_skipped is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_authentication_skipped is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::authentication_skipped, zeek::Args{
	        c->GetVal(),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr login_prompt; 
void zeek::BifEvent::enqueue_login_prompt(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> prompt)
	{
	// Note that it is intentional that here we do not
	// check if ::login_prompt is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_login_prompt is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::login_prompt, zeek::Args{
	        c->GetVal(),
	        std::move(prompt),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr activating_encryption; 
void zeek::BifEvent::enqueue_activating_encryption(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c)
	{
	// Note that it is intentional that here we do not
	// check if ::activating_encryption is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_activating_encryption is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::activating_encryption, zeek::Args{
	        c->GetVal(),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr inconsistent_option; 
void zeek::BifEvent::enqueue_inconsistent_option(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c)
	{
	// Note that it is intentional that here we do not
	// check if ::inconsistent_option is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_inconsistent_option is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::inconsistent_option, zeek::Args{
	        c->GetVal(),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr bad_option; 
void zeek::BifEvent::enqueue_bad_option(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c)
	{
	// Note that it is intentional that here we do not
	// check if ::bad_option is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_bad_option is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::bad_option, zeek::Args{
	        c->GetVal(),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr bad_option_termination; 
void zeek::BifEvent::enqueue_bad_option_termination(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c)
	{
	// Note that it is intentional that here we do not
	// check if ::bad_option_termination is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_bad_option_termination is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::bad_option_termination, zeek::Args{
	        c->GetVal(),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

