// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/mime/events.bif (plugin mode).


#include "events.bif.h"
#include "zeek/Func.h"

zeek::EventHandlerPtr mime_begin_entity; 
void zeek::BifEvent::enqueue_mime_begin_entity(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_begin_entity is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_mime_begin_entity is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::mime_begin_entity, zeek::Args{
	        c->GetVal(),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr mime_end_entity; 
void zeek::BifEvent::enqueue_mime_end_entity(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_end_entity is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_mime_end_entity is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::mime_end_entity, zeek::Args{
	        c->GetVal(),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr mime_one_header; 
void zeek::BifEvent::enqueue_mime_one_header(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> h)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_one_header is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_mime_one_header is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::mime_one_header, zeek::Args{
	        c->GetVal(),
	        std::move(h),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr mime_all_headers; 
void zeek::BifEvent::enqueue_mime_all_headers(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> hlist)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_all_headers is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_mime_all_headers is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::mime_all_headers, zeek::Args{
	        c->GetVal(),
	        std::move(hlist),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr mime_segment_data; 
void zeek::BifEvent::enqueue_mime_segment_data(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek_uint_t length, zeek::IntrusivePtr<zeek::StringVal> data)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_segment_data is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_mime_segment_data is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::mime_segment_data, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Count(length),
	        std::move(data),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr mime_entity_data; 
void zeek::BifEvent::enqueue_mime_entity_data(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek_uint_t length, zeek::IntrusivePtr<zeek::StringVal> data)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_entity_data is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_mime_entity_data is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::mime_entity_data, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Count(length),
	        std::move(data),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr mime_all_data; 
void zeek::BifEvent::enqueue_mime_all_data(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek_uint_t length, zeek::IntrusivePtr<zeek::StringVal> data)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_all_data is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_mime_all_data is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::mime_all_data, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Count(length),
	        std::move(data),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr mime_event; 
void zeek::BifEvent::enqueue_mime_event(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> event_type, zeek::IntrusivePtr<zeek::StringVal> detail)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_event is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_mime_event is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::mime_event, zeek::Args{
	        c->GetVal(),
	        std::move(event_type),
	        std::move(detail),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr mime_content_hash; 
void zeek::BifEvent::enqueue_mime_content_hash(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek_uint_t content_len, zeek::IntrusivePtr<zeek::StringVal> hash_value)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_content_hash is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_mime_content_hash is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::mime_content_hash, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Count(content_len),
	        std::move(hash_value),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

