// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/rdp/events.bif (plugin mode).


#include "events.bif.h"
#include "zeek/Func.h"

zeek::EventHandlerPtr rdpeudp_syn; 
void zeek::BifEvent::enqueue_rdpeudp_syn(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c)
	{
	// Note that it is intentional that here we do not
	// check if ::rdpeudp_syn is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rdpeudp_syn is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rdpeudp_syn, zeek::Args{
	        c->GetVal(),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr rdpeudp_synack; 
void zeek::BifEvent::enqueue_rdpeudp_synack(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c)
	{
	// Note that it is intentional that here we do not
	// check if ::rdpeudp_synack is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rdpeudp_synack is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rdpeudp_synack, zeek::Args{
	        c->GetVal(),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr rdpeudp_established; 
void zeek::BifEvent::enqueue_rdpeudp_established(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek_uint_t version)
	{
	// Note that it is intentional that here we do not
	// check if ::rdpeudp_established is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rdpeudp_established is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rdpeudp_established, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Count(version),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr rdpeudp_data; 
void zeek::BifEvent::enqueue_rdpeudp_data(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek_uint_t version, zeek::IntrusivePtr<zeek::StringVal> data)
	{
	// Note that it is intentional that here we do not
	// check if ::rdpeudp_data is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rdpeudp_data is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rdpeudp_data, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        zeek::val_mgr->Count(version),
	        std::move(data),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr rdp_native_encrypted_data; 
void zeek::BifEvent::enqueue_rdp_native_encrypted_data(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int orig, zeek_uint_t len)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_native_encrypted_data is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rdp_native_encrypted_data is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rdp_native_encrypted_data, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(orig),
	        zeek::val_mgr->Count(len),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr rdp_connect_request; 
void zeek::BifEvent::enqueue_rdp_connect_request(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> cookie, zeek_uint_t flags)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_connect_request is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rdp_connect_request is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rdp_connect_request, zeek::Args{
	        c->GetVal(),
	        std::move(cookie),
	        zeek::val_mgr->Count(flags),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr rdp_negotiation_response; 
void zeek::BifEvent::enqueue_rdp_negotiation_response(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek_uint_t security_protocol, zeek_uint_t flags)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_negotiation_response is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rdp_negotiation_response is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rdp_negotiation_response, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Count(security_protocol),
	        zeek::val_mgr->Count(flags),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr rdp_negotiation_failure; 
void zeek::BifEvent::enqueue_rdp_negotiation_failure(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek_uint_t failure_code, zeek_uint_t flags)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_negotiation_failure is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rdp_negotiation_failure is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rdp_negotiation_failure, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Count(failure_code),
	        zeek::val_mgr->Count(flags),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr rdp_client_core_data; 
void zeek::BifEvent::enqueue_rdp_client_core_data(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> data)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_client_core_data is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rdp_client_core_data is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rdp_client_core_data, zeek::Args{
	        c->GetVal(),
	        std::move(data),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr rdp_client_security_data; 
void zeek::BifEvent::enqueue_rdp_client_security_data(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> data)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_client_security_data is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rdp_client_security_data is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rdp_client_security_data, zeek::Args{
	        c->GetVal(),
	        std::move(data),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr rdp_client_network_data; 
void zeek::BifEvent::enqueue_rdp_client_network_data(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> channels)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_client_network_data is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rdp_client_network_data is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rdp_client_network_data, zeek::Args{
	        c->GetVal(),
	        std::move(channels),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr rdp_client_cluster_data; 
void zeek::BifEvent::enqueue_rdp_client_cluster_data(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> data)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_client_cluster_data is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rdp_client_cluster_data is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rdp_client_cluster_data, zeek::Args{
	        c->GetVal(),
	        std::move(data),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr rdp_gcc_server_create_response; 
void zeek::BifEvent::enqueue_rdp_gcc_server_create_response(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek_uint_t result)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_gcc_server_create_response is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rdp_gcc_server_create_response is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rdp_gcc_server_create_response, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Count(result),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr rdp_server_security; 
void zeek::BifEvent::enqueue_rdp_server_security(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek_uint_t encryption_method, zeek_uint_t encryption_level)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_server_security is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rdp_server_security is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rdp_server_security, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Count(encryption_method),
	        zeek::val_mgr->Count(encryption_level),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr rdp_server_certificate; 
void zeek::BifEvent::enqueue_rdp_server_certificate(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek_uint_t cert_type, int permanently_issued)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_server_certificate is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rdp_server_certificate is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rdp_server_certificate, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Count(cert_type),
	        zeek::val_mgr->Bool(permanently_issued),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr rdp_begin_encryption; 
void zeek::BifEvent::enqueue_rdp_begin_encryption(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek_uint_t security_protocol)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_begin_encryption is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_rdp_begin_encryption is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::rdp_begin_encryption, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Count(security_protocol),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

