// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/sip/events.bif (plugin mode).


#include "events.bif.h"
#include "zeek/Func.h"

zeek::EventHandlerPtr sip_request; 
void zeek::BifEvent::enqueue_sip_request(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> method, zeek::IntrusivePtr<zeek::StringVal> original_URI, zeek::IntrusivePtr<zeek::StringVal> version)
	{
	// Note that it is intentional that here we do not
	// check if ::sip_request is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_sip_request is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::sip_request, zeek::Args{
	        c->GetVal(),
	        std::move(method),
	        std::move(original_URI),
	        std::move(version),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr sip_reply; 
void zeek::BifEvent::enqueue_sip_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> version, zeek_uint_t code, zeek::IntrusivePtr<zeek::StringVal> reason)
	{
	// Note that it is intentional that here we do not
	// check if ::sip_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_sip_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::sip_reply, zeek::Args{
	        c->GetVal(),
	        std::move(version),
	        zeek::val_mgr->Count(code),
	        std::move(reason),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr sip_header; 
void zeek::BifEvent::enqueue_sip_header(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> name, zeek::IntrusivePtr<zeek::StringVal> value)
	{
	// Note that it is intentional that here we do not
	// check if ::sip_header is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_sip_header is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::sip_header, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(name),
	        std::move(value),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr sip_all_headers; 
void zeek::BifEvent::enqueue_sip_all_headers(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::Val> hlist)
	{
	// Note that it is intentional that here we do not
	// check if ::sip_all_headers is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_sip_all_headers is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::sip_all_headers, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(hlist),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr sip_begin_entity; 
void zeek::BifEvent::enqueue_sip_begin_entity(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig)
	{
	// Note that it is intentional that here we do not
	// check if ::sip_begin_entity is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_sip_begin_entity is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::sip_begin_entity, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr sip_end_entity; 
void zeek::BifEvent::enqueue_sip_end_entity(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig)
	{
	// Note that it is intentional that here we do not
	// check if ::sip_end_entity is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_sip_end_entity is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::sip_end_entity, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

