// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssh/events.bif (plugin mode).


#include "events.bif.h"
#include "zeek/Func.h"

zeek::EventHandlerPtr ssh_server_version; 
void zeek::BifEvent::enqueue_ssh_server_version(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> version)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh_server_version is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ssh_server_version is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ssh_server_version, zeek::Args{
	        c->GetVal(),
	        std::move(version),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr ssh_client_version; 
void zeek::BifEvent::enqueue_ssh_client_version(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> version)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh_client_version is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ssh_client_version is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ssh_client_version, zeek::Args{
	        c->GetVal(),
	        std::move(version),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr ssh_auth_successful; 
void zeek::BifEvent::enqueue_ssh_auth_successful(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int auth_method_none)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh_auth_successful is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ssh_auth_successful is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ssh_auth_successful, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(auth_method_none),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr ssh_auth_attempted; 
void zeek::BifEvent::enqueue_ssh_auth_attempted(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int authenticated)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh_auth_attempted is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ssh_auth_attempted is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ssh_auth_attempted, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(authenticated),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr ssh_capabilities; 
void zeek::BifEvent::enqueue_ssh_capabilities(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> cookie, zeek::IntrusivePtr<zeek::Val> capabilities)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh_capabilities is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ssh_capabilities is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ssh_capabilities, zeek::Args{
	        c->GetVal(),
	        std::move(cookie),
	        std::move(capabilities),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr ssh2_server_host_key; 
void zeek::BifEvent::enqueue_ssh2_server_host_key(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> key)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh2_server_host_key is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ssh2_server_host_key is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ssh2_server_host_key, zeek::Args{
	        c->GetVal(),
	        std::move(key),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr ssh1_server_host_key; 
void zeek::BifEvent::enqueue_ssh1_server_host_key(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> modulus, zeek::IntrusivePtr<zeek::StringVal> exponent)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh1_server_host_key is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ssh1_server_host_key is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ssh1_server_host_key, zeek::Args{
	        c->GetVal(),
	        std::move(modulus),
	        std::move(exponent),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr ssh_server_host_key; 
void zeek::BifEvent::enqueue_ssh_server_host_key(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> hash)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh_server_host_key is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ssh_server_host_key is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ssh_server_host_key, zeek::Args{
	        c->GetVal(),
	        std::move(hash),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr ssh_encrypted_packet; 
void zeek::BifEvent::enqueue_ssh_encrypted_packet(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int orig, zeek_uint_t len)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh_encrypted_packet is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ssh_encrypted_packet is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ssh_encrypted_packet, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(orig),
	        zeek::val_mgr->Count(len),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr ssh2_dh_server_params; 
void zeek::BifEvent::enqueue_ssh2_dh_server_params(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::StringVal> p, zeek::IntrusivePtr<zeek::StringVal> q)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh2_dh_server_params is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ssh2_dh_server_params is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ssh2_dh_server_params, zeek::Args{
	        c->GetVal(),
	        std::move(p),
	        std::move(q),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr ssh2_gss_error; 
void zeek::BifEvent::enqueue_ssh2_gss_error(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek_uint_t major_status, zeek_uint_t minor_status, zeek::IntrusivePtr<zeek::StringVal> err_msg)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh2_gss_error is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ssh2_gss_error is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ssh2_gss_error, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Count(major_status),
	        zeek::val_mgr->Count(minor_status),
	        std::move(err_msg),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr ssh2_ecc_key; 
void zeek::BifEvent::enqueue_ssh2_ecc_key(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig, zeek::IntrusivePtr<zeek::StringVal> q)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh2_ecc_key is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ssh2_ecc_key is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ssh2_ecc_key, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        std::move(q),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr ssh2_ecc_init; 
void zeek::BifEvent::enqueue_ssh2_ecc_init(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh2_ecc_init is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ssh2_ecc_init is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ssh2_ecc_init, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr ssh2_dh_gex_init; 
void zeek::BifEvent::enqueue_ssh2_dh_gex_init(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh2_dh_gex_init is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ssh2_dh_gex_init is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ssh2_dh_gex_init, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr ssh2_gss_init; 
void zeek::BifEvent::enqueue_ssh2_gss_init(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh2_gss_init is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ssh2_gss_init is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ssh2_gss_init, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr ssh2_rsa_secret; 
void zeek::BifEvent::enqueue_ssh2_rsa_secret(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, int is_orig)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh2_rsa_secret is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ssh2_rsa_secret is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ssh2_rsa_secret, zeek::Args{
	        c->GetVal(),
	        zeek::val_mgr->Bool(is_orig),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

