// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif (plugin mode).


#include "functions.bif.h"
#include "zeek/Func.h"


#line 2 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif"

#include <openssl/x509.h>
#include "zeek/analyzer/protocol/ssl/SSL.h"
#include "zeek/Reporter.h"

#line 14 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::set_ssl_established_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 15 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("set_ssl_established() takes exactly 1 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Connection* c = (zeek::Connection*) ((*BiF_ARGS)[0].get()->AsRecordVal()->GetOrigin());

#line 15 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif"

	zeek::analyzer::Analyzer* sa = c->FindAnalyzer("SSL");

	if ( sa )
		{
		static_cast<zeek::analyzer::ssl::SSL_Analyzer*>(sa)->StartEncryption();
		return zeek::val_mgr->True();
		}

	return zeek::val_mgr->False();
	} // end of BifFunc::set_ssl_established

#line 25 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif"

#line 35 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::set_secret_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 36 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("set_secret() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Connection* c = (zeek::Connection*) ((*BiF_ARGS)[0].get()->AsRecordVal()->GetOrigin());
	zeek::StringVal* secret = (zeek::StringVal*) ((*BiF_ARGS)[1].get()->AsStringVal());

#line 36 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif"

	analyzer::Analyzer* sa = c->FindAnalyzer("SSL");

	if ( sa )
		{
		static_cast<zeek::analyzer::ssl::SSL_Analyzer*>(sa)->SetSecret(*secret);
		return zeek::val_mgr->True();
		}

	return zeek::val_mgr->False();
	} // end of BifFunc::set_secret

#line 46 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif"

#line 56 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::set_keys_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 57 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("set_keys() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Connection* c = (zeek::Connection*) ((*BiF_ARGS)[0].get()->AsRecordVal()->GetOrigin());
	zeek::StringVal* keys = (zeek::StringVal*) ((*BiF_ARGS)[1].get()->AsStringVal());

#line 57 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif"

	analyzer::Analyzer* sa = c->FindAnalyzer("SSL");

	if ( sa )
		{
		static_cast<zeek::analyzer::ssl::SSL_Analyzer*>(sa)->SetKeys(*keys);
		return zeek::val_mgr->True();
		}

	return zeek::val_mgr->False();
	} // end of BifFunc::set_keys

#line 67 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif"

#line 77 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::parse_distinguished_name_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 78 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("parse_distinguished_name() takes exactly 1 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::StringVal* dn = (zeek::StringVal*) ((*BiF_ARGS)[0].get()->AsStringVal());

#line 78 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif"

	const unsigned char* in = dn->Bytes();

	X509_NAME* dn_x509 = d2i_X509_NAME(nullptr, &in, dn->Len());
	if ( ! dn_x509 )
		{
		// we were not able to parse. Let's return an empty string.
		return zeek::make_intrusive<zeek::StringVal>("");
		}

	char buf[256];
	memset(buf, 0, sizeof(buf));
	BIO* bio = BIO_new(BIO_s_mem());

	X509_NAME_print_ex(bio, dn_x509, 0, XN_FLAG_RFC2253);
	int len = BIO_gets(bio, buf, sizeof(buf));
	auto out = zeek::make_intrusive<zeek::StringVal>(len, buf);
	BIO_free(bio);
	X509_NAME_free(dn_x509);
	return out;
	} // end of BifFunc::parse_distinguished_name

#line 98 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/ssl/functions.bif"
