// This file is automatically generated from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/syslog/legacy/syslog.pac.

#ifndef _builddir_build_BUILD_zeek_6_0_4_build_zeek_6_0_4_src_analyzer_protocol_syslog_legacy_syslog_pac_h
#define _builddir_build_BUILD_zeek_6_0_4_build_zeek_6_0_4_src_analyzer_protocol_syslog_legacy_syslog_pac_h

#include <vector>

#include "binpac.h"


#include "zeek/binpac_zeek.h"


#include "zeek/analyzer/protocol/syslog/legacy/events.bif.h"

namespace binpac {

namespace Syslog {
class ContextSyslog;
class Syslog_Message_Optional_PRI;
class Syslog_Message;
extern RegExMatcher Syslog_Priority_re_001;

class Syslog_Priority;
class Syslog_Conn;
class Syslog_Flow;
} // namespace Syslog

int bytestring_to_int(const_bytestring const & s, int base);
double bytestring_to_double(const_bytestring const & s);
int bytestring_casecmp(const_bytestring const & s1, const_charptr const & s2);
bool bytestring_caseprefix(const_bytestring const & s1, const_charptr const & s2);
double network_time();
namespace Syslog {

class ContextSyslog final
{
public:
	ContextSyslog(Syslog_Conn * connection, Syslog_Flow * flow);
	~ContextSyslog();
	
	// Member access functions
	Syslog_Conn * connection() const { return connection_; }
	Syslog_Flow * flow() const { return flow_; }
	
protected:
	Syslog_Conn * connection_;
	Syslog_Flow * flow_;
};


class Syslog_Message_Optional_PRI final
{
public:
	Syslog_Message_Optional_PRI();
	~Syslog_Message_Optional_PRI();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSyslog * t_context);
	
	// Member access functions
	uint8 lt() const { return lt_; }
	int byteorder() const { return byteorder_; }
	Syslog_Message * standard() const { BINPAC_ASSERT(has_standard()); return standard_; }
	bool has_standard() const { return has_standard_; }
	Syslog_Message * nonstandard() const { BINPAC_ASSERT(has_nonstandard()); return nonstandard_; }
	bool has_nonstandard() const { return has_nonstandard_; }
	const_bytestring const & sourcedata() const { return sourcedata_; }
	
protected:
	uint8 lt_;
	const_bytestring after_lt_;
	int byteorder_;
	Syslog_Message * standard_;
	bool has_standard_;
	Syslog_Message * nonstandard_;
	bool has_nonstandard_;
	const_bytestring sourcedata_;
};


class Syslog_Message final
{
public:
	Syslog_Message(bool has_pri);
	~Syslog_Message();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSyslog * t_context);
	
	// Member access functions
	int opt_pri_case_index() const	{ return opt_pri_case_index_; }
	Syslog_Priority * PRI() const
		{
		switch ( opt_pri_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/analyzer/protocol/syslog/legacy/syslog-protocol.pac:14:PRI", (int64)opt_pri_case_index(), "true");
				break;
			}
		return PRI_;
		}
	bytestring const & msg() const { return msg_; }
	bool has_pri() const { return has_pri_; }
	int byteorder() const { return byteorder_; }
	int proc_syslog_message() const { return proc_syslog_message_; }
	
protected:
	int opt_pri_case_index_;
	Syslog_Priority * PRI_;
	bytestring msg_;
	bool has_pri_;
	int byteorder_;
	int proc_syslog_message_;
};


class Syslog_Priority final
{
public:
	Syslog_Priority();
	~Syslog_Priority();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint8 lt() const { return lt_; }
	bytestring const & val() const { return val_; }
	uint8 gt() const { return gt_; }
	int val_length() const { return val_length_; }
	int int_val() const { return int_val_; }
	int severity() const { return severity_; }
	int facility() const { return facility_; }
	
protected:
	uint8 lt_;
	bytestring val_;
	uint8 gt_;
	int val_length_;
	int int_val_;
	int severity_;
	int facility_;
};


class Syslog_Conn final : public binpac::ConnectionAnalyzer
{
public:
	Syslog_Conn(ZeekAnalyzer const & zeek_analyzer);
	~Syslog_Conn();
	
	// Member access functions
	Syslog_Flow * upflow() const { return upflow_; }
	Syslog_Flow * downflow() const { return downflow_; }
	ZeekAnalyzer const & zeek_analyzer() const { return zeek_analyzer_; }
	
	void NewData(bool is_orig, const_byteptr begin, const_byteptr end);
	void NewGap(bool is_orig, int gap_length);
	void FlowEOF(bool is_orig);
	
protected:
	Syslog_Flow * upflow_;
	Syslog_Flow * downflow_;
	ZeekAnalyzer zeek_analyzer_;
};


class Syslog_Flow final : public binpac::FlowAnalyzer
{
public:
	Syslog_Flow(Syslog_Conn * connection);
	~Syslog_Flow();
	
	// Member access functions
	Syslog_Conn * connection() const { return connection_; }
	
	void NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data);
	void NewGap(int gap_length);
	void FlowEOF();
	
	// Functions
	bool process_syslog_message(Syslog_Message * m);
	
protected:
	Syslog_Message_Optional_PRI * dataunit_;
	ContextSyslog * context_;
	Syslog_Conn * connection_;
};

} // namespace Syslog
}  // namespace binpac
#endif /* _builddir_build_BUILD_zeek_6_0_4_build_zeek_6_0_4_src_analyzer_protocol_syslog_legacy_syslog_pac_h */
