// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/file_analysis/analyzer/x509/ocsp_events.bif (plugin mode).


#include "ocsp_events.bif.h"
#include "zeek/Func.h"

zeek::EventHandlerPtr ocsp_request; 
void zeek::BifEvent::enqueue_ocsp_request(zeek::analyzer::Analyzer* analyzer, zeek::IntrusivePtr<zeek::Val> f, zeek_uint_t version)
	{
	// Note that it is intentional that here we do not
	// check if ::ocsp_request is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ocsp_request is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ocsp_request, zeek::Args{
	        std::move(f),
	        zeek::val_mgr->Count(version),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0);
	}

zeek::EventHandlerPtr ocsp_request_certificate; 
void zeek::BifEvent::enqueue_ocsp_request_certificate(zeek::analyzer::Analyzer* analyzer, zeek::IntrusivePtr<zeek::Val> f, zeek::IntrusivePtr<zeek::StringVal> hashAlgorithm, zeek::IntrusivePtr<zeek::StringVal> issuerNameHash, zeek::IntrusivePtr<zeek::StringVal> issuerKeyHash, zeek::IntrusivePtr<zeek::StringVal> serialNumber)
	{
	// Note that it is intentional that here we do not
	// check if ::ocsp_request_certificate is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ocsp_request_certificate is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ocsp_request_certificate, zeek::Args{
	        std::move(f),
	        std::move(hashAlgorithm),
	        std::move(issuerNameHash),
	        std::move(issuerKeyHash),
	        std::move(serialNumber),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0);
	}

zeek::EventHandlerPtr ocsp_response_status; 
void zeek::BifEvent::enqueue_ocsp_response_status(zeek::analyzer::Analyzer* analyzer, zeek::IntrusivePtr<zeek::Val> f, zeek::IntrusivePtr<zeek::StringVal> status)
	{
	// Note that it is intentional that here we do not
	// check if ::ocsp_response_status is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ocsp_response_status is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ocsp_response_status, zeek::Args{
	        std::move(f),
	        std::move(status),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0);
	}

zeek::EventHandlerPtr ocsp_response_bytes; 
void zeek::BifEvent::enqueue_ocsp_response_bytes(zeek::analyzer::Analyzer* analyzer, zeek::IntrusivePtr<zeek::Val> f, zeek::IntrusivePtr<zeek::StringVal> status, zeek_uint_t version, zeek::IntrusivePtr<zeek::StringVal> responderId, double producedAt, zeek::IntrusivePtr<zeek::StringVal> signatureAlgorithm, zeek::IntrusivePtr<zeek::Val> certs)
	{
	// Note that it is intentional that here we do not
	// check if ::ocsp_response_bytes is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ocsp_response_bytes is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ocsp_response_bytes, zeek::Args{
	        std::move(f),
	        std::move(status),
	        zeek::val_mgr->Count(version),
	        std::move(responderId),
	        zeek::make_intrusive<zeek::TimeVal>(producedAt),
	        std::move(signatureAlgorithm),
	        std::move(certs),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0);
	}

zeek::EventHandlerPtr ocsp_response_certificate; 
void zeek::BifEvent::enqueue_ocsp_response_certificate(zeek::analyzer::Analyzer* analyzer, zeek::IntrusivePtr<zeek::Val> f, zeek::IntrusivePtr<zeek::StringVal> hashAlgorithm, zeek::IntrusivePtr<zeek::StringVal> issuerNameHash, zeek::IntrusivePtr<zeek::StringVal> issuerKeyHash, zeek::IntrusivePtr<zeek::StringVal> serialNumber, zeek::IntrusivePtr<zeek::StringVal> certStatus, double revokeTime, zeek::IntrusivePtr<zeek::StringVal> revokeReason, double thisUpdate, double nextUpdate)
	{
	// Note that it is intentional that here we do not
	// check if ::ocsp_response_certificate is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ocsp_response_certificate is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ocsp_response_certificate, zeek::Args{
	        std::move(f),
	        std::move(hashAlgorithm),
	        std::move(issuerNameHash),
	        std::move(issuerKeyHash),
	        std::move(serialNumber),
	        std::move(certStatus),
	        zeek::make_intrusive<zeek::TimeVal>(revokeTime),
	        std::move(revokeReason),
	        zeek::make_intrusive<zeek::TimeVal>(thisUpdate),
	        zeek::make_intrusive<zeek::TimeVal>(nextUpdate),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0);
	}

zeek::EventHandlerPtr ocsp_extension; 
void zeek::BifEvent::enqueue_ocsp_extension(zeek::analyzer::Analyzer* analyzer, zeek::IntrusivePtr<zeek::Val> f, zeek::IntrusivePtr<zeek::Val> ext, int global_resp)
	{
	// Note that it is intentional that here we do not
	// check if ::ocsp_extension is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_ocsp_extension is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::ocsp_extension, zeek::Args{
	        std::move(f),
	        std::move(ext),
	        zeek::val_mgr->Bool(global_resp),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0);
	}

