// This file is automatically generated from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/file_analysis/analyzer/x509/x509-extension.pac.

#ifndef _builddir_build_BUILD_zeek_6_0_4_build_zeek_6_0_4_src_file_analysis_analyzer_x509_x509_extension_pac_h
#define _builddir_build_BUILD_zeek_6_0_4_build_zeek_6_0_4_src_file_analysis_analyzer_x509_x509_extension_pac_h

#include <vector>

#include "binpac.h"


#include "zeek/binpac_zeek.h"


#include "zeek/file_analysis/File.h"

#include "zeek/file_analysis/analyzer/x509/types.bif.h"
#include "zeek/file_analysis/analyzer/x509/events.bif.h"

namespace binpac {

namespace X509Extension {
class ContextX509Extension;
class MockConnection;
class SignatureAndHashAlgorithm;
class SignedCertificateTimestampList;
class SignedCertificateTimestamp;
class HandshakeRecord;
class SignedCertTimestampExt;
} // namespace X509Extension

int bytestring_to_int(const_bytestring const & s, int base);
double bytestring_to_double(const_bytestring const & s);
int bytestring_casecmp(const_bytestring const & s1, const_charptr const & s2);
bool bytestring_caseprefix(const_bytestring const & s1, const_charptr const & s2);
double network_time();
namespace X509Extension {

class ContextX509Extension final
{
public:
	ContextX509Extension(MockConnection * connection, SignedCertTimestampExt * flow, FlowBuffer * flow_buffer);
	~ContextX509Extension();
	
	// Member access functions
	MockConnection * connection() const { return connection_; }
	SignedCertTimestampExt * flow() const { return flow_; }
	FlowBuffer * flow_buffer() const { return flow_buffer_; }
	
protected:
	MockConnection * connection_;
	SignedCertTimestampExt * flow_;
	FlowBuffer * flow_buffer_;
};


class MockConnection final : public binpac::ConnectionAnalyzer
{
public:
	MockConnection(ZeekFileAnalyzer * zeek_analyzer);
	~MockConnection();
	
	// Member access functions
	SignedCertTimestampExt * upflow() const { return upflow_; }
	SignedCertTimestampExt * downflow() const { return downflow_; }
	ZeekFileAnalyzer * zeek_analyzer() const { return zeek_analyzer_; }
	
	void NewData(bool is_orig, const_byteptr begin, const_byteptr end);
	void NewGap(bool is_orig, int gap_length);
	void FlowEOF(bool is_orig);
	
	// Functions
	bool proc_signedcertificatetimestamp(HandshakeRecord * rec, uint8 version, const_bytestring const & logid, uint64 timestamp, SignatureAndHashAlgorithm * digitally_signed_algorithms, const_bytestring const & digitally_signed_signature);
	
protected:
	SignedCertTimestampExt * upflow_;
	SignedCertTimestampExt * downflow_;
	ZeekFileAnalyzer * zeek_analyzer_;
};


class SignatureAndHashAlgorithm final
{
public:
	SignatureAndHashAlgorithm();
	~SignatureAndHashAlgorithm();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint8 HashAlgorithm() const { return HashAlgorithm_; }
	uint8 SignatureAlgorithm() const { return SignatureAlgorithm_; }
	
protected:
	uint8 HashAlgorithm_;
	uint8 SignatureAlgorithm_;
};


class SignedCertificateTimestampList final
{
public:
	SignedCertificateTimestampList(HandshakeRecord * rec);
	~SignedCertificateTimestampList();
	int initial_buffer_length() const { return 2; }
	bool ParseBuffer(flow_buffer_t t_flow_buffer, ContextX509Extension * t_context, int t_byteorder);
	
	// Member access functions
	uint16 length() const { return length_; }
	vector<SignedCertificateTimestamp *> * SCTs() const { return SCTs_; }
	HandshakeRecord * rec() const { return rec_; }
	
protected:
	uint16 length_;
	vector<SignedCertificateTimestamp *> * SCTs_;
	SignedCertificateTimestamp * SCTs__elem_;
	HandshakeRecord * rec_;
	int buffering_state_;
};


class SignedCertificateTimestamp final
{
public:
	SignedCertificateTimestamp(HandshakeRecord * rec);
	~SignedCertificateTimestamp();
	int initial_buffer_length() const { return 2; }
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextX509Extension * t_context, int t_byteorder);
	
	// Member access functions
	uint16 length() const { return length_; }
	uint8 version() const { return version_; }
	bytestring const & logid() const { return logid_; }
	uint64 timestamp() const { return timestamp_; }
	uint16 extensions_length() const { return extensions_length_; }
	bytestring const & extensions() const { return extensions_; }
	SignatureAndHashAlgorithm * digitally_signed_algorithms() const { return digitally_signed_algorithms_; }
	uint16 digitally_signed_signature_length() const { return digitally_signed_signature_length_; }
	bytestring const & digitally_signed_signature() const { return digitally_signed_signature_; }
	HandshakeRecord * rec() const { return rec_; }
	bool proc() const { return proc_; }
	
protected:
	uint16 length_;
	uint8 version_;
	bytestring logid_;
	uint64 timestamp_;
	uint16 extensions_length_;
	bytestring extensions_;
	SignatureAndHashAlgorithm * digitally_signed_algorithms_;
	uint16 digitally_signed_signature_length_;
	bytestring digitally_signed_signature_;
	HandshakeRecord * rec_;
	bool proc_;
};


class HandshakeRecord final
{
public:
	HandshakeRecord();
	~HandshakeRecord();
	bool ParseBuffer(flow_buffer_t t_flow_buffer, ContextX509Extension * t_context);
	
	// Member access functions
	int byteorder() const { return byteorder_; }
	
protected:
	vector<SignedCertificateTimestampList *> * signed_certificate_timestamp_list_;
	SignedCertificateTimestampList * signed_certificate_timestamp_list__elem_;
	int signed_certificate_timestamp_list__arraylength_;
	int signed_certificate_timestamp_list__elem__it_;
	int byteorder_;
	int parsing_state_;
};


class SignedCertTimestampExt final : public binpac::FlowAnalyzer
{
public:
	SignedCertTimestampExt(MockConnection * connection);
	~SignedCertTimestampExt();
	
	// Member access functions
	FlowBuffer * flow_buffer() const { return flow_buffer_; }
	MockConnection * connection() const { return connection_; }
	
	void NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data);
	void NewGap(int gap_length);
	void FlowEOF();
	
protected:
	HandshakeRecord * dataunit_;
	ContextX509Extension * context_;
	FlowBuffer * flow_buffer_;
	MockConnection * connection_;
};

} // namespace X509Extension
}  // namespace binpac
#endif /* _builddir_build_BUILD_zeek_6_0_4_build_zeek_6_0_4_src_file_analysis_analyzer_x509_x509_extension_pac_h */
