// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/packet_analysis/protocol/icmp/events.bif (plugin mode).


#include "events.bif.h"
#include "zeek/Func.h"

zeek::EventHandlerPtr icmp_sent; 
void zeek::BifEvent::enqueue_icmp_sent(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> info)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_sent is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_icmp_sent is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::icmp_sent, zeek::Args{
	        c->GetVal(),
	        std::move(info),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr icmp_sent_payload; 
void zeek::BifEvent::enqueue_icmp_sent_payload(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> info, zeek::IntrusivePtr<zeek::StringVal> payload)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_sent_payload is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_icmp_sent_payload is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::icmp_sent_payload, zeek::Args{
	        c->GetVal(),
	        std::move(info),
	        std::move(payload),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr icmp_echo_request; 
void zeek::BifEvent::enqueue_icmp_echo_request(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> info, zeek_uint_t id, zeek_uint_t seq, zeek::IntrusivePtr<zeek::StringVal> payload)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_echo_request is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_icmp_echo_request is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::icmp_echo_request, zeek::Args{
	        c->GetVal(),
	        std::move(info),
	        zeek::val_mgr->Count(id),
	        zeek::val_mgr->Count(seq),
	        std::move(payload),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr icmp_echo_reply; 
void zeek::BifEvent::enqueue_icmp_echo_reply(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> info, zeek_uint_t id, zeek_uint_t seq, zeek::IntrusivePtr<zeek::StringVal> payload)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_echo_reply is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_icmp_echo_reply is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::icmp_echo_reply, zeek::Args{
	        c->GetVal(),
	        std::move(info),
	        zeek::val_mgr->Count(id),
	        zeek::val_mgr->Count(seq),
	        std::move(payload),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr icmp_error_message; 
void zeek::BifEvent::enqueue_icmp_error_message(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> info, zeek_uint_t code, zeek::IntrusivePtr<zeek::Val> context)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_error_message is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_icmp_error_message is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::icmp_error_message, zeek::Args{
	        c->GetVal(),
	        std::move(info),
	        zeek::val_mgr->Count(code),
	        std::move(context),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr icmp_unreachable; 
void zeek::BifEvent::enqueue_icmp_unreachable(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> info, zeek_uint_t code, zeek::IntrusivePtr<zeek::Val> context)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_unreachable is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_icmp_unreachable is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::icmp_unreachable, zeek::Args{
	        c->GetVal(),
	        std::move(info),
	        zeek::val_mgr->Count(code),
	        std::move(context),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr icmp_packet_too_big; 
void zeek::BifEvent::enqueue_icmp_packet_too_big(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> info, zeek_uint_t code, zeek::IntrusivePtr<zeek::Val> context)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_packet_too_big is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_icmp_packet_too_big is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::icmp_packet_too_big, zeek::Args{
	        c->GetVal(),
	        std::move(info),
	        zeek::val_mgr->Count(code),
	        std::move(context),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr icmp_time_exceeded; 
void zeek::BifEvent::enqueue_icmp_time_exceeded(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> info, zeek_uint_t code, zeek::IntrusivePtr<zeek::Val> context)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_time_exceeded is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_icmp_time_exceeded is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::icmp_time_exceeded, zeek::Args{
	        c->GetVal(),
	        std::move(info),
	        zeek::val_mgr->Count(code),
	        std::move(context),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr icmp_parameter_problem; 
void zeek::BifEvent::enqueue_icmp_parameter_problem(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> info, zeek_uint_t code, zeek::IntrusivePtr<zeek::Val> context)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_parameter_problem is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_icmp_parameter_problem is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::icmp_parameter_problem, zeek::Args{
	        c->GetVal(),
	        std::move(info),
	        zeek::val_mgr->Count(code),
	        std::move(context),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr icmp_router_solicitation; 
void zeek::BifEvent::enqueue_icmp_router_solicitation(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> info, zeek::IntrusivePtr<zeek::Val> options)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_router_solicitation is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_icmp_router_solicitation is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::icmp_router_solicitation, zeek::Args{
	        c->GetVal(),
	        std::move(info),
	        std::move(options),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr icmp_router_advertisement; 
void zeek::BifEvent::enqueue_icmp_router_advertisement(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> info, zeek_uint_t cur_hop_limit, int managed, int other, int home_agent, zeek_uint_t pref, int proxy, zeek_uint_t rsv, double router_lifetime, double reachable_time, double retrans_timer, zeek::IntrusivePtr<zeek::Val> options)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_router_advertisement is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_icmp_router_advertisement is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::icmp_router_advertisement, zeek::Args{
	        c->GetVal(),
	        std::move(info),
	        zeek::val_mgr->Count(cur_hop_limit),
	        zeek::val_mgr->Bool(managed),
	        zeek::val_mgr->Bool(other),
	        zeek::val_mgr->Bool(home_agent),
	        zeek::val_mgr->Count(pref),
	        zeek::val_mgr->Bool(proxy),
	        zeek::val_mgr->Count(rsv),
	        zeek::make_intrusive<zeek::IntervalVal>(router_lifetime, Seconds),
	        zeek::make_intrusive<zeek::IntervalVal>(reachable_time, Seconds),
	        zeek::make_intrusive<zeek::IntervalVal>(retrans_timer, Seconds),
	        std::move(options),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr icmp_neighbor_solicitation; 
void zeek::BifEvent::enqueue_icmp_neighbor_solicitation(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> info, zeek::IntrusivePtr<zeek::AddrVal> tgt, zeek::IntrusivePtr<zeek::Val> options)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_neighbor_solicitation is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_icmp_neighbor_solicitation is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::icmp_neighbor_solicitation, zeek::Args{
	        c->GetVal(),
	        std::move(info),
	        std::move(tgt),
	        std::move(options),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr icmp_neighbor_advertisement; 
void zeek::BifEvent::enqueue_icmp_neighbor_advertisement(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> info, int router, int solicited, int override, zeek::IntrusivePtr<zeek::AddrVal> tgt, zeek::IntrusivePtr<zeek::Val> options)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_neighbor_advertisement is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_icmp_neighbor_advertisement is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::icmp_neighbor_advertisement, zeek::Args{
	        c->GetVal(),
	        std::move(info),
	        zeek::val_mgr->Bool(router),
	        zeek::val_mgr->Bool(solicited),
	        zeek::val_mgr->Bool(override),
	        std::move(tgt),
	        std::move(options),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

zeek::EventHandlerPtr icmp_redirect; 
void zeek::BifEvent::enqueue_icmp_redirect(zeek::analyzer::Analyzer* analyzer, zeek::Connection* c, zeek::IntrusivePtr<zeek::Val> info, zeek::IntrusivePtr<zeek::AddrVal> tgt, zeek::IntrusivePtr<zeek::AddrVal> dest, zeek::IntrusivePtr<zeek::Val> options)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_redirect is NULL, which should happen *before*
	// zeek::BifEvent::enqueue_icmp_redirect is called to avoid unnecessary Val
	// allocation.

	zeek::event_mgr.Enqueue(::icmp_redirect, zeek::Args{
	        c->GetVal(),
	        std::move(info),
	        std::move(tgt),
	        std::move(dest),
	        std::move(options),
	        },
	    zeek::util::detail::SOURCE_LOCAL, analyzer ? analyzer->GetID() : 0, c);
	}

