// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif (alternative mode).


#include "telemetry.bif.h"
#include "zeek/Func.h"

namespace zeek { namespace BifType { namespace Enum{ namespace Telemetry {  zeek::IntrusivePtr<zeek::EnumType> MetricType;  } } }}
namespace BifType { namespace Enum{ namespace Telemetry {  zeek::EnumType * MetricType;  } } }

#line 14 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#include "zeek/telemetry/Counter.h"
#include "zeek/telemetry/Gauge.h"
#include "zeek/telemetry/Histogram.h"
#include "zeek/telemetry/Manager.h"

namespace {

template <class ScriptHandle, class Fun>
auto with(zeek::Val* val, const char* error_msg, Fun fun)
	{
	if ( auto ptr = dynamic_cast<ScriptHandle*>(val) )
		{
		fun(ptr->GetHandle());
		return zeek::val_mgr->True();
		}
	else
		{
		zeek::reporter->Error("%s", error_msg);
		return zeek::val_mgr->False();
		}
	}

std::string_view sv(const zeek::String* str) noexcept
	{
	auto len = static_cast<size_t>(str->Len());
	return {reinterpret_cast<char*>(str->Bytes()), len};
	};

std::string_view sv(const zeek::StringVal* val) noexcept
	{
	return sv(val->AsString());
	};

std::vector<std::string_view> sv_vec(zeek::VectorVal* xs)
	{
	std::vector<std::string_view> result;
	if ( xs )
		for ( unsigned index = 0; index < xs->Size(); ++index )
			if ( auto ptr = xs->ValAt(index) )
				if ( auto* str = ptr->AsString() )
					result.emplace_back(sv(str));
	return result;
	}

std::vector<zeek::telemetry::LabelView> sv_tbl(zeek::TableVal* xs)
	{
	std::vector<zeek::telemetry::LabelView> result;
	if ( xs )
		{
		for ( auto& val : *xs->Get() )
			{
			auto val_ptr = val.value->GetVal();
			result.emplace_back(std::string_view{val.GetKey(), val.key_size},
			                    sv(val_ptr->AsStringVal()));
			}
		}
	return result;
	}

bool is_valid(zeek::Span<const zeek::telemetry::LabelView> labels,
              zeek::Span<const std::string> label_names)
	{
	auto key_in_label_names = [keys{label_names}](auto x)
		{
		return std::find(keys.begin(), keys.end(), x.first) != keys.end();
		};
	return labels.size() == label_names.size()
	       && std::all_of(labels.begin(), labels.end(), key_in_label_names);
	}

template <class IntOrDbl>
auto to_std_vec(zeek::VectorVal* xs)
	{
	std::vector<IntOrDbl> result;
	if( xs )
		for ( unsigned index = 0; index < xs->Size() ; ++index )
			{
			if constexpr (std::is_same<IntOrDbl, int64_t>::value)
				result.emplace_back(xs->ValAt(index)->AsInt());
			else
				result.emplace_back(xs->ValAt(index)->AsDouble());
			}
	return result;
	}

template <class IntOrDbl>
auto to_std_vec(zeek::Val* xs)
	{
	return to_std_vec<IntOrDbl>(xs->AsVectorVal());
	}

}

#line 111 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__int_counter_family_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 117 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 6 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__int_counter_family() takes exactly 6 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::StringVal* prefix = (zeek::StringVal*) ((*BiF_ARGS)[0].get()->AsStringVal());
	zeek::StringVal* name = (zeek::StringVal*) ((*BiF_ARGS)[1].get()->AsStringVal());
	zeek::Val* labels = (zeek::Val*) ((*BiF_ARGS)[2].get());
	zeek::StringVal* helptext = (zeek::StringVal*) ((*BiF_ARGS)[3].get()->AsStringVal());
	zeek::StringVal* unit = (zeek::StringVal*) ((*BiF_ARGS)[4].get()->AsStringVal());
	int is_sum = (int) ((*BiF_ARGS)[5].get()->AsBool());

#line 117 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	auto lbl_vec = sv_vec(labels->AsVectorVal());
	auto hdl = telemetry_mgr->CounterFamily(sv(prefix), sv(name), lbl_vec,
	                                        sv(helptext), sv(unit), is_sum);
	return zeek::make_intrusive<IntCounterMetricFamilyVal>(hdl);
	} // end of BifFunc::Telemetry::__int_counter_family

#line 122 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 124 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__int_counter_metric_get_or_add_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 126 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__int_counter_metric_get_or_add() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* family = (zeek::Val*) ((*BiF_ARGS)[0].get());
	zeek::Val* labels = (zeek::Val*) ((*BiF_ARGS)[1].get());

#line 126 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	using ResultType = zeek::IntrusivePtr<IntCounterMetricFamilyVal>;
	if ( auto ptr = dynamic_cast<zeek::IntCounterMetricFamilyVal*>(family) )
		{
		auto hdl = ptr->GetHandle();
		auto lbl_map = sv_tbl(labels->AsTableVal());
		if ( is_valid(lbl_map, hdl.LabelNames()) )
			{
			auto res = hdl.GetOrAdd(lbl_map);
			return zeek::make_intrusive<IntCounterMetricVal>(res);
			}
		else
			{
			zeek::reporter->Error("Telemetry::int_counter_metric_get_or_add: invalid label dimensions.");
			return ResultType{nullptr};
			}
		}
	else
		{
		zeek::reporter->Error("Telemetry::int_counter_metric_get_or_add: invalid handle.");
		return ResultType{nullptr};
		}
	} // end of BifFunc::Telemetry::__int_counter_metric_get_or_add

#line 148 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 150 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__int_counter_inc_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 152 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__int_counter_inc() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* val = (zeek::Val*) ((*BiF_ARGS)[0].get());
	zeek_int_t amount = (zeek_int_t) ((*BiF_ARGS)[1].get()->AsInt());

#line 152 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	return with<IntCounterMetricVal>(val, "Telemetry::int_counter_inc: invalid handle.", [amount](auto hdl) { hdl.Inc(amount); });
	} // end of BifFunc::Telemetry::__int_counter_inc

#line 154 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 156 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__int_counter_value_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 157 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__int_counter_value() takes exactly 1 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* val = (zeek::Val*) ((*BiF_ARGS)[0].get());

#line 157 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	if ( auto ptr = dynamic_cast<zeek::IntCounterMetricVal*>(val) )
		{
		return zeek::val_mgr->Int(ptr->GetHandle().Value());
		}
	else
		{
		zeek::reporter->Error("Telemetry::int_counter_value: invalid handle.");
		return zeek::val_mgr->Int(0);
		}
	} // end of BifFunc::Telemetry::__int_counter_value

#line 167 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 171 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__dbl_counter_family_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 177 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 6 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__dbl_counter_family() takes exactly 6 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::StringVal* prefix = (zeek::StringVal*) ((*BiF_ARGS)[0].get()->AsStringVal());
	zeek::StringVal* name = (zeek::StringVal*) ((*BiF_ARGS)[1].get()->AsStringVal());
	zeek::Val* labels = (zeek::Val*) ((*BiF_ARGS)[2].get());
	zeek::StringVal* helptext = (zeek::StringVal*) ((*BiF_ARGS)[3].get()->AsStringVal());
	zeek::StringVal* unit = (zeek::StringVal*) ((*BiF_ARGS)[4].get()->AsStringVal());
	int is_sum = (int) ((*BiF_ARGS)[5].get()->AsBool());

#line 177 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	auto lbl_vec = sv_vec(labels->AsVectorVal());
	auto hdl = telemetry_mgr->CounterFamily<double>(sv(prefix), sv(name), lbl_vec,
	                                                sv(helptext), sv(unit), is_sum);
	return zeek::make_intrusive<DblCounterMetricFamilyVal>(hdl);
	} // end of BifFunc::Telemetry::__dbl_counter_family

#line 182 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 184 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__dbl_counter_metric_get_or_add_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 186 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__dbl_counter_metric_get_or_add() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* family = (zeek::Val*) ((*BiF_ARGS)[0].get());
	zeek::Val* labels = (zeek::Val*) ((*BiF_ARGS)[1].get());

#line 186 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	using ResultType = zeek::IntrusivePtr<DblCounterMetricFamilyVal>;
	if ( auto ptr = dynamic_cast<zeek::DblCounterMetricFamilyVal*>(family) )
		{
		auto hdl = ptr->GetHandle();
		auto lbl_map = sv_tbl(labels->AsTableVal());
		if ( is_valid(lbl_map, hdl.LabelNames()) )
			{
			auto res = hdl.GetOrAdd(lbl_map);
			return zeek::make_intrusive<DblCounterMetricVal>(res);
			}
		else
			{
			zeek::reporter->Error("Telemetry::dbl_counter_metric_get_or_add: invalid label dimensions.");
			return ResultType{nullptr};
			}
		}
	else
		{
		zeek::reporter->Error("Telemetry::dbl_counter_metric_get_or_add: invalid handle.");
		return ResultType{nullptr};
		}
	} // end of BifFunc::Telemetry::__dbl_counter_metric_get_or_add

#line 208 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 210 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__dbl_counter_inc_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 212 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__dbl_counter_inc() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* val = (zeek::Val*) ((*BiF_ARGS)[0].get());
	double amount = (double) ((*BiF_ARGS)[1].get()->AsDouble());

#line 212 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	return with<DblCounterMetricVal>(val, "Telemetry::dbl_counter_inc: invalid handle.", [amount](auto hdl) { hdl.Inc(amount); });
	} // end of BifFunc::Telemetry::__dbl_counter_inc

#line 214 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 216 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__dbl_counter_value_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 217 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__dbl_counter_value() takes exactly 1 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* val = (zeek::Val*) ((*BiF_ARGS)[0].get());

#line 217 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	if ( auto ptr = dynamic_cast<zeek::DblCounterMetricVal*>(val) )
		{
		return zeek::make_intrusive<DoubleVal>(ptr->GetHandle().Value());
		}
	else
		{
		zeek::reporter->Error("Telemetry::dbl_counter_value: invalid handle.");
		return zeek::make_intrusive<DoubleVal>(0.0);
		}
	} // end of BifFunc::Telemetry::__dbl_counter_value

#line 227 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 231 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__int_gauge_family_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 237 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 6 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__int_gauge_family() takes exactly 6 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::StringVal* prefix = (zeek::StringVal*) ((*BiF_ARGS)[0].get()->AsStringVal());
	zeek::StringVal* name = (zeek::StringVal*) ((*BiF_ARGS)[1].get()->AsStringVal());
	zeek::Val* labels = (zeek::Val*) ((*BiF_ARGS)[2].get());
	zeek::StringVal* helptext = (zeek::StringVal*) ((*BiF_ARGS)[3].get()->AsStringVal());
	zeek::StringVal* unit = (zeek::StringVal*) ((*BiF_ARGS)[4].get()->AsStringVal());
	int is_sum = (int) ((*BiF_ARGS)[5].get()->AsBool());

#line 237 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	auto lbl_vec = sv_vec(labels->AsVectorVal());
	auto hdl = telemetry_mgr->GaugeFamily(sv(prefix), sv(name), lbl_vec,
	                                        sv(helptext), sv(unit), is_sum);
	return zeek::make_intrusive<IntGaugeMetricFamilyVal>(hdl);
	} // end of BifFunc::Telemetry::__int_gauge_family

#line 242 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 244 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__int_gauge_metric_get_or_add_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 246 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__int_gauge_metric_get_or_add() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* family = (zeek::Val*) ((*BiF_ARGS)[0].get());
	zeek::Val* labels = (zeek::Val*) ((*BiF_ARGS)[1].get());

#line 246 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	using ResultType = zeek::IntrusivePtr<IntGaugeMetricFamilyVal>;
	if ( auto ptr = dynamic_cast<zeek::IntGaugeMetricFamilyVal*>(family) )
		{
		auto hdl = ptr->GetHandle();
		auto lbl_map = sv_tbl(labels->AsTableVal());
		if ( is_valid(lbl_map, hdl.LabelNames()) )
			{
			auto res = hdl.GetOrAdd(lbl_map);
			return zeek::make_intrusive<IntGaugeMetricVal>(res);
			}
		else
			{
			zeek::reporter->Error("Telemetry::int_gauge_metric_get_or_add: invalid label dimensions.");
			return ResultType{nullptr};
			}
		}
	else
		{
		zeek::reporter->Error("Telemetry::int_gauge_metric_get_or_add: invalid handle.");
		return ResultType{nullptr};
		}
	} // end of BifFunc::Telemetry::__int_gauge_metric_get_or_add

#line 268 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 270 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__int_gauge_inc_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 272 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__int_gauge_inc() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* val = (zeek::Val*) ((*BiF_ARGS)[0].get());
	zeek_int_t amount = (zeek_int_t) ((*BiF_ARGS)[1].get()->AsInt());

#line 272 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	return with<IntGaugeMetricVal>(val, "Telemetry::int_gauge_inc: invalid handle.", [amount](auto hdl) { hdl.Inc(amount); });
	} // end of BifFunc::Telemetry::__int_gauge_inc

#line 274 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 276 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__int_gauge_dec_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 278 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__int_gauge_dec() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* val = (zeek::Val*) ((*BiF_ARGS)[0].get());
	zeek_int_t amount = (zeek_int_t) ((*BiF_ARGS)[1].get()->AsInt());

#line 278 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	return with<IntGaugeMetricVal>(val, "Telemetry::int_gauge_dec: invalid handle.", [amount](auto hdl) { hdl.Dec(amount); });
	} // end of BifFunc::Telemetry::__int_gauge_dec

#line 280 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 282 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__int_gauge_value_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 283 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__int_gauge_value() takes exactly 1 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* val = (zeek::Val*) ((*BiF_ARGS)[0].get());

#line 283 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	if ( auto ptr = dynamic_cast<zeek::IntGaugeMetricVal*>(val) )
		{
		return zeek::val_mgr->Int(ptr->GetHandle().Value());
		}
	else
		{
		zeek::reporter->Error("Telemetry::int_gauge_value: invalid handle.");
		return zeek::val_mgr->Int(0);
		}
	} // end of BifFunc::Telemetry::__int_gauge_value

#line 293 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 297 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__dbl_gauge_family_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 303 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 6 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__dbl_gauge_family() takes exactly 6 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::StringVal* prefix = (zeek::StringVal*) ((*BiF_ARGS)[0].get()->AsStringVal());
	zeek::StringVal* name = (zeek::StringVal*) ((*BiF_ARGS)[1].get()->AsStringVal());
	zeek::Val* labels = (zeek::Val*) ((*BiF_ARGS)[2].get());
	zeek::StringVal* helptext = (zeek::StringVal*) ((*BiF_ARGS)[3].get()->AsStringVal());
	zeek::StringVal* unit = (zeek::StringVal*) ((*BiF_ARGS)[4].get()->AsStringVal());
	int is_sum = (int) ((*BiF_ARGS)[5].get()->AsBool());

#line 303 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	auto lbl_vec = sv_vec(labels->AsVectorVal());
	auto hdl = telemetry_mgr->GaugeFamily<double>(sv(prefix), sv(name), lbl_vec,
	                                              sv(helptext), sv(unit), is_sum);
	return zeek::make_intrusive<DblGaugeMetricFamilyVal>(hdl);
	} // end of BifFunc::Telemetry::__dbl_gauge_family

#line 308 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 310 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__dbl_gauge_metric_get_or_add_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 312 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__dbl_gauge_metric_get_or_add() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* family = (zeek::Val*) ((*BiF_ARGS)[0].get());
	zeek::Val* labels = (zeek::Val*) ((*BiF_ARGS)[1].get());

#line 312 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	using ResultType = zeek::IntrusivePtr<DblGaugeMetricFamilyVal>;
	if ( auto ptr = dynamic_cast<zeek::DblGaugeMetricFamilyVal*>(family) )
		{
		auto hdl = ptr->GetHandle();
		auto lbl_map = sv_tbl(labels->AsTableVal());
		if ( is_valid(lbl_map, hdl.LabelNames()) )
			{
			auto res = hdl.GetOrAdd(lbl_map);
			return zeek::make_intrusive<DblGaugeMetricVal>(res);
			}
		else
			{
			zeek::reporter->Error("Telemetry::dbl_gauge_metric_get_or_add: invalid label dimensions.");
			return ResultType{nullptr};
			}
		}
	else
		{
		zeek::reporter->Error("Telemetry::dbl_gauge_metric_get_or_add: invalid handle.");
		return ResultType{nullptr};
		}
	} // end of BifFunc::Telemetry::__dbl_gauge_metric_get_or_add

#line 334 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 336 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__dbl_gauge_inc_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 338 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__dbl_gauge_inc() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* val = (zeek::Val*) ((*BiF_ARGS)[0].get());
	double amount = (double) ((*BiF_ARGS)[1].get()->AsDouble());

#line 338 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	return with<DblGaugeMetricVal>(val, "Telemetry::dbl_gauge_inc: invalid handle.", [amount](auto hdl) { hdl.Inc(amount); });
	} // end of BifFunc::Telemetry::__dbl_gauge_inc

#line 340 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 342 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__dbl_gauge_dec_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 344 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__dbl_gauge_dec() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* val = (zeek::Val*) ((*BiF_ARGS)[0].get());
	double amount = (double) ((*BiF_ARGS)[1].get()->AsDouble());

#line 344 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	return with<DblGaugeMetricVal>(val, "Telemetry::dbl_gauge_dec: invalid handle.", [amount](auto hdl) { hdl.Dec(amount); });
	} // end of BifFunc::Telemetry::__dbl_gauge_dec

#line 346 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 348 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__dbl_gauge_value_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 349 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__dbl_gauge_value() takes exactly 1 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* val = (zeek::Val*) ((*BiF_ARGS)[0].get());

#line 349 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	if ( auto ptr = dynamic_cast<zeek::DblGaugeMetricVal*>(val) )
		{
		return zeek::make_intrusive<DoubleVal>(ptr->GetHandle().Value());
		}
	else
		{
		zeek::reporter->Error("Telemetry::dbl_gauge_value: invalid handle.");
		return zeek::make_intrusive<DoubleVal>(0.0);
		}
	} // end of BifFunc::Telemetry::__dbl_gauge_value

#line 359 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 363 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__int_histogram_family_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 370 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 7 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__int_histogram_family() takes exactly 7 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::StringVal* prefix = (zeek::StringVal*) ((*BiF_ARGS)[0].get()->AsStringVal());
	zeek::StringVal* name = (zeek::StringVal*) ((*BiF_ARGS)[1].get()->AsStringVal());
	zeek::Val* labels = (zeek::Val*) ((*BiF_ARGS)[2].get());
	zeek::Val* bounds = (zeek::Val*) ((*BiF_ARGS)[3].get());
	zeek::StringVal* helptext = (zeek::StringVal*) ((*BiF_ARGS)[4].get()->AsStringVal());
	zeek::StringVal* unit = (zeek::StringVal*) ((*BiF_ARGS)[5].get()->AsStringVal());
	int is_sum = (int) ((*BiF_ARGS)[6].get()->AsBool());

#line 370 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	auto lbl_vec = sv_vec(labels->AsVectorVal());
	auto std_bounds = to_std_vec<int64_t>(bounds);
	auto hdl = telemetry_mgr->HistogramFamily(sv(prefix), sv(name), lbl_vec,
	                                          std_bounds, sv(helptext),
	                                          sv(unit), is_sum);
	return zeek::make_intrusive<IntHistogramMetricFamilyVal>(hdl);
	} // end of BifFunc::Telemetry::__int_histogram_family

#line 377 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 379 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__int_histogram_metric_get_or_add_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 381 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__int_histogram_metric_get_or_add() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* family = (zeek::Val*) ((*BiF_ARGS)[0].get());
	zeek::Val* labels = (zeek::Val*) ((*BiF_ARGS)[1].get());

#line 381 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	using ResultType = zeek::IntrusivePtr<IntHistogramMetricFamilyVal>;
	if ( auto ptr = dynamic_cast<zeek::IntHistogramMetricFamilyVal*>(family) )
		{
		auto hdl = ptr->GetHandle();
		auto lbl_map = sv_tbl(labels->AsTableVal());
		if ( is_valid(lbl_map, hdl.LabelNames()) )
			{
			auto res = hdl.GetOrAdd(lbl_map);
			return zeek::make_intrusive<IntHistogramMetricVal>(res);
			}
		else
			{
			zeek::reporter->Error("Telemetry::int_histogram_metric_get_or_add: invalid label dimensions.");
			return ResultType{nullptr};
			}
		}
	else
		{
		zeek::reporter->Error("Telemetry::int_histogram_metric_get_or_add: invalid handle.");
		return ResultType{nullptr};
		}
	} // end of BifFunc::Telemetry::__int_histogram_metric_get_or_add

#line 403 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 405 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__int_histogram_observe_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 407 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__int_histogram_observe() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* val = (zeek::Val*) ((*BiF_ARGS)[0].get());
	zeek_int_t measurement = (zeek_int_t) ((*BiF_ARGS)[1].get()->AsInt());

#line 407 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	return with<IntHistogramMetricVal>(val, "Telemetry::int_histogram_inc: invalid handle.", [measurement](auto hdl) { hdl.Observe(measurement); });
	} // end of BifFunc::Telemetry::__int_histogram_observe

#line 409 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 411 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__int_histogram_sum_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 412 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__int_histogram_sum() takes exactly 1 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* val = (zeek::Val*) ((*BiF_ARGS)[0].get());

#line 412 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	if ( auto ptr = dynamic_cast<zeek::IntHistogramMetricVal*>(val) )
		{
		return zeek::val_mgr->Int(ptr->GetHandle().Sum());
		}
	else
		{
		zeek::reporter->Error("Telemetry::int_histogram_sum: invalid handle.");
		return zeek::val_mgr->Int(0);
		}
	} // end of BifFunc::Telemetry::__int_histogram_sum

#line 422 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 426 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__dbl_histogram_family_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 433 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 7 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__dbl_histogram_family() takes exactly 7 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::StringVal* prefix = (zeek::StringVal*) ((*BiF_ARGS)[0].get()->AsStringVal());
	zeek::StringVal* name = (zeek::StringVal*) ((*BiF_ARGS)[1].get()->AsStringVal());
	zeek::Val* labels = (zeek::Val*) ((*BiF_ARGS)[2].get());
	zeek::Val* bounds = (zeek::Val*) ((*BiF_ARGS)[3].get());
	zeek::StringVal* helptext = (zeek::StringVal*) ((*BiF_ARGS)[4].get()->AsStringVal());
	zeek::StringVal* unit = (zeek::StringVal*) ((*BiF_ARGS)[5].get()->AsStringVal());
	int is_sum = (int) ((*BiF_ARGS)[6].get()->AsBool());

#line 433 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	auto lbl_vec = sv_vec(labels->AsVectorVal());
	auto std_bounds = to_std_vec<double>(bounds);
	auto hdl = telemetry_mgr->HistogramFamily<double>(sv(prefix), sv(name),
	                                                  lbl_vec, std_bounds,
	                                                  sv(helptext), sv(unit),
	                                                  is_sum);
	return zeek::make_intrusive<DblHistogramMetricFamilyVal>(hdl);
	} // end of BifFunc::Telemetry::__dbl_histogram_family

#line 441 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 443 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__dbl_histogram_metric_get_or_add_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 445 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__dbl_histogram_metric_get_or_add() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* family = (zeek::Val*) ((*BiF_ARGS)[0].get());
	zeek::Val* labels = (zeek::Val*) ((*BiF_ARGS)[1].get());

#line 445 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	using ResultType = zeek::IntrusivePtr<DblHistogramMetricFamilyVal>;
	if ( auto ptr = dynamic_cast<zeek::DblHistogramMetricFamilyVal*>(family) )
		{
		auto hdl = ptr->GetHandle();
		auto lbl_map = sv_tbl(labels->AsTableVal());
		if ( is_valid(lbl_map, hdl.LabelNames()) )
			{
			auto res = hdl.GetOrAdd(lbl_map);
			return zeek::make_intrusive<DblHistogramMetricVal>(res);
			}
		else
			{
			zeek::reporter->Error("Telemetry::dbl_histogram_metric_get_or_add: invalid label dimensions.");
			return ResultType{nullptr};
			}
		}
	else
		{
		zeek::reporter->Error("Telemetry::dbl_histogram_metric_get_or_add: invalid handle.");
		return ResultType{nullptr};
		}
	} // end of BifFunc::Telemetry::__dbl_histogram_metric_get_or_add

#line 467 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 469 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__dbl_histogram_observe_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 471 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__dbl_histogram_observe() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* val = (zeek::Val*) ((*BiF_ARGS)[0].get());
	double measurement = (double) ((*BiF_ARGS)[1].get()->AsDouble());

#line 471 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	return with<DblHistogramMetricVal>(val, "Telemetry::dbl_histogram_inc: invalid handle.", [measurement](auto hdl) { hdl.Observe(measurement); });
	} // end of BifFunc::Telemetry::__dbl_histogram_observe

#line 473 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 475 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__dbl_histogram_sum_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 476 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__dbl_histogram_sum() takes exactly 1 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::Val* val = (zeek::Val*) ((*BiF_ARGS)[0].get());

#line 476 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	if ( auto ptr = dynamic_cast<zeek::DblHistogramMetricVal*>(val) )
		{
		return zeek::make_intrusive<DoubleVal>(ptr->GetHandle().Sum());
		}
	else
		{
		zeek::reporter->Error("Telemetry::dbl_histogram_sum: invalid handle.");
		return zeek::make_intrusive<DoubleVal>(0.0);
		}
	} // end of BifFunc::Telemetry::__dbl_histogram_sum

#line 486 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 488 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__collect_metrics_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 489 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__collect_metrics() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::StringVal* prefix = (zeek::StringVal*) ((*BiF_ARGS)[0].get()->AsStringVal());
	zeek::StringVal* name = (zeek::StringVal*) ((*BiF_ARGS)[1].get()->AsStringVal());

#line 489 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	auto metrics = telemetry_mgr->CollectMetrics(sv(prefix), sv(name));

	static auto metrics_vector_type = zeek::id::find_type<VectorType>("any_vec");
	auto vec = zeek::make_intrusive<VectorVal>(metrics_vector_type);

	for ( const auto& m : metrics )
		vec->Append(m.AsMetricRecord());

	return vec;
	} // end of BifFunc::Telemetry::__collect_metrics

#line 499 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

#line 501 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
zeek::detail::BifReturnVal zeek::BifFunc::Telemetry::__collect_histogram_metrics_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 502 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		zeek::emit_builtin_error(zeek::util::fmt("Telemetry::__collect_histogram_metrics() takes exactly 2 argument(s), got %lu", BiF_ARGS->size()));
		return nullptr;
		}
	zeek::StringVal* prefix = (zeek::StringVal*) ((*BiF_ARGS)[0].get()->AsStringVal());
	zeek::StringVal* name = (zeek::StringVal*) ((*BiF_ARGS)[1].get()->AsStringVal());

#line 502 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"

	auto metrics = telemetry_mgr->CollectHistogramMetrics(sv(prefix), sv(name));

	static auto metrics_vector_type = zeek::id::find_type<VectorType>("any_vec");
	auto vec = zeek::make_intrusive<VectorVal>(metrics_vector_type);

	for ( const auto& m : metrics )
		vec->Append(m.AsHistogramMetricRecord());

	return vec;
	} // end of BifFunc::Telemetry::__collect_histogram_metrics

#line 512 "/builddir/build/BUILD/zeek-6.0.4-build/zeek-6.0.4/src/telemetry/telemetry.bif"
